%  ALL THE DDE CODES ARE GIVEN BELOW. THE FIRST TWO LINES GIVES
%  THE TITLE OF THE PROBLEM AND THE FIGURE GENERATED RESPECTIVELY.
%  UNCOMMENT EACH CODE (leave the first two lines of each code) AND
%  RUN THE CODE.


%%---5.2.1---Delayed Protein Degradation------%
%%---Figure5.1---%

% function sol = hepat1
% sol = dde23(@hepat1f,20.0,@hepat1h,[0, 200]);
%  figure(1)
%  plot(sol.x,sol.y)
%  %plot(sol.x,sol.y(3,:))
%  xlabel('Time');
%  ylabel('t-Protein Concentration P(t)');
%  
% function v = hepat1h(t)
% v = [150];
% %---------------------------------------------
% function dy = hepat1f(t,y,Z)
%  alpha = 40; 
%  beta = 0.3; 
%  gamma = 0.1; 
% %------------------------------------------------
% ylag1 = Z(:,1);      
% dy = alpha - beta*y(1)-gamma*ylag1(1);


% function sol = hepat1
% sol = dde23(@hepat1f,10.0,@hepat1h,[0, 200]);
%  figure(2)
%  plot(sol.x,sol.y)
%  %plot(sol.x,sol.y(3,:))
%  xlabel('Time');
%  ylabel('t-Protein Concentration P(t)');
%  
% function v = hepat1h(t)
% v = [20];
% %---------------------------------------------
% function dy = hepat1f(t,y,Z)
%  alpha = 100; 
%  beta = 1.1; 
%  gamma = 1.0; 
% %------------------------------------------------
% ylag1 = Z(:,1);      
% dy = alpha - beta*y(1)-gamma*ylag1(1);


%----5.2.2-----Football Team Model--------%
%%---Figure5.2---%

% function sol = DDE_one
% sol = dde23(@DDE_onef,2,@hepat1h,[0, 40]);
%  figure
%  hold on;
%  plot(sol.x,sol.y(1,:))
%  xlabel('t-Time');
%  ylabel('x(t)');
% function v = hepat1h(t)
% v = [0.4];
% %---------------------------------------------
% function dy = DDE_onef(t,y,Z)
% b = 0.785;
%  %------------------------------------------------
% ylag1 = Z(:,1);  
% dy = b*(0.5-ylag1(1));



%%--5.2.3----Breathing Problem------%
%%---Figure5.3---%

% function sol = hepat1
% sol = dde23(@hepat1f,0.25,@hepat1h,[0, 5]);
%  figure(2)
%  plot(sol.x,sol.y)
%  %plot(sol.x,sol.y(3,:))
%  xlabel('t-Time');
%  ylabel('Carbondioxide Content C(t)');
%  
% function v = hepat1h(t)
% v = [1.2];
% %---------------------------------------------
% function dy = hepat1f(t,y,Z)
%  lamda = 6;
%  alpha = 1.0;
%  Vm = 80; 
%  n = 3;
% %------------------------------------------------
% ylag1 = Z(:,1);      
% dy = lamda - alpha*Vm*y(1)*(ylag1(1))^n/(1+ (ylag1(1))^n);



%%-5.2.4-----Housefly Model------%
%%---Figure5.4---%

% function sol = hepat1
% sol = dde23(@hepat1f,5,@hepat1h,[0, 300]);
%  figure(2)
%  plot(sol.x,sol.y)
%  %plot(sol.x,sol.y(3,:))
%  xlabel('t-Time');
%  ylabel('Number of Adult Houseflies H(t)');
%  
% function v = hepat1h(t)
% v = [100];
% %---------------------------------------------
% function dy = hepat1f(t,y,Z)
%  d1 = 0.147;
%  beta = 1.81;
%  k = 0.5107; 
%  M = 0.000226;
% %------------------------------------------------
% ylag1 = Z(:,1);      
% dy =  -d1*y(1) + beta*ylag1(1)*(k - beta*M*ylag1(1));



%%--5.2.5----Shower Problem-----%
%%---Figure5.5---%

% function sol = DDE_one
% sol = dde23(@DDE_onef,1,@hepat1h,[0, 15]);
%  figure
%  hold on;
%  plot(sol.x,sol.y(1,:))
%  xlabel('t-Time');
%  ylabel('x(t)');
% function v = hepat1h(t)
% v = [0.5];
% %---------------------------------------------
% function dy = DDE_onef(t,y,Z)
% alpha = 2.8;
% Td = 40;
%  %------------------------------------------------
% ylag1 = Z(:,1);  
% dy = -alpha*(ylag1(1)- Td);




%%--5.2.6----Two Neuron System-----%
%%---Figure5.6---%

% function sol = hepat1
% sol = dde23(@hepat1f,[0.4 0.6],@hepat1h,[0, 100]);
%  figure(4)
%  hold on;
%  plot(sol.x,sol.y(1,:))
%  xlabel('t-Time');
%  ylabel('Voltage on the inputs of first Neurons u_{  1}(t)');
%  figure(2)
%  plot(sol.x,sol.y(2,:))
%  %plot(sol.x,sol.y(3,:))
%  xlabel('t-Time');
%  ylabel('Voltage on the inputs of second Neurons u_{  2}(t)');
%  figure(3)
%  plot(sol.y(1,:),sol.y(2,:))
%  xlabel('u_{ 1}(t)');
%  ylabel('u_{ 2}(t)');
% function v = hepat1h(t)
% v = [0.1 0.3];
% %---------------------------------------------
% function dy = hepat1f(t,y,Z)
%  a1 = 2;
%  a2 = -1.5
%  %------------------------------------------------
% ylag1 = Z(:,1);  
% ylag2 = Z(:,2);
% dy = [-y(1) + a1*tanh(ylag2(2));
%     -y(2) + a2*tanh(ylag1(1))]




%%MISCELLANEOUS EXAMPLES%%

%%---5.4.1---Mackey Glass Model------%
%%---Figure5.7---%

% function sol = hepat1
% sol = dde23(@hepat1f,15,@hepat1h,[0, 1000]);
%  figure(1)
%  hold on;
%  plot(sol.x,sol.y)
%  %plot(sol.x,sol.y(3,:))
%  xlabel('t-Time');
%  ylabel('Number of Blood Cells B(t)');
%  
% function v = hepat1h(t)
% v = [0.1];
% %---------------------------------------------
% function dy = hepat1f(t,y,Z)
%  lamda = 0.2;
%  alpha = 1.0;
%  m = 10; 
%  beta = 0.1;
% %------------------------------------------------
% ylag1 = Z(:,1);      
% dy = lamda*alpha^m*ylag1(1)/(alpha^m+ (ylag1(1))^m)-beta*y(1);




%%--5.4.2----Second Order Delayed Feedback-----%
%%---Figure5.8---%

% function sol = DDE_one
% sol = dde23(@DDE_onef,2,@hepat1h,[0, 100]);
%  figure
%  hold on;
%  plot(sol.x,sol.y(1,:))
%  xlabel('t-Time');
%  ylabel('x(t)');
% function v = hepat1h(t)
% v = [0.1 0.1];
% %---------------------------------------------
% function dy = DDE_onef(t,y,Z)
%  %------------------------------------------------
% ylag1 = Z(:,1);  
% dy = [y(2); 
%     -y(2)-3*y(1)-sqrt(5)*tanh(ylag1(1))];



%%-5.4.3-----Epidemic Model------%
%%---Figure5.9---%

% function sol = hepat1
% sol = dde23(@hepat1f,7,@hepat1h,[0, 80]);
%  figure
%  plot(sol.x,sol.y)
%  xlabel('t-Time');
%  ylabel('Population y(t)');
%  
% function v = hepat1h(t)
% v = [0.8];
% %---------------------------------------------
% function dy = hepat1f(t,y,Z)
%  b = 2;
%  c = 1.0;
% %------------------------------------------------
% ylag1 = Z(:,1);      
% dy =  b*ylag1(1)*(1-y(1))- c*y(1);



%---5.4.4---Microbial Growth Model--------%
%----Figure

% function sol = DDE_one
% sol = dde23(@DDE_onef,0.1,@hepat1h,[0, 20]);
%  figure
%  hold on;
%  plot(sol.x,sol.y)
%  xlabel('t-Time');
%  ylabel('x(t)');
% function v = hepat1h(t)
% v = [2, 14];
% %---------------------------------------------
% function dy = DDE_onef(t,y,Z)
% m = 0.7;
% a = 2;
%  %------------------------------------------------
% ylag1 = Z(:,1);  
% dy = [1-y(1) - m*y(1)*y(2)/(a + y(1));
%     exp(-.001)*m*ylag1(1)*ylag1(2)/(a + ylag1(1))-y(2)];


%--5.4.5----Delayed Lotka-Volterra System-----%
%---Figure

% function sol = hepat1
% sol = dde23(@hepat1f,[20],@hepat1h,[0, 100]);
%  figure
%  plot(sol.y(1,:),sol.y(2,:))
%  xlabel('t-Time');
%  ylabel('Population');
% function v = hepat1h(t)
% v = [1 0.8];
% %---------------------------------------------
% function dy = hepat1f(t,y,Z)
%  %alpha = 2;
%  %beta = 1;
%  %gamma = 1;
%  %delta = 2;
%  alpha = 1;
%  beta = 2;
%  gamma = 2;
%  delta = 1;
%  %------------------------------------------------
% ylag1 = Z(:,1);  
% dy = [y(1)*(2-alpha*y(1)-beta*ylag1(2));
%       y(2)*(2-gamma*ylag1(1)-delta*y(2))]


% %--5.4.6----Gene Regulatory System-----%
% %---Figure5.9---%

% function sol = hepat1
% sol = dde23(@hepat1f,[3.5],@hepat1h,[0, 50]);
%  figure
%  plot(sol.x,sol.y(1,:))
%  xlabel('t-Time');
%  ylabel('Intercellular mRNA R(t)');
%  %plot(sol.x,sol.y(2,:))
%  %plot(sol.x,sol.y(3,:))
%  %xlabel('t-Time');
%  %ylabel('Protein product of the gene P(t)');
%  %figure(3)
%  %plot(sol.y(1,:),sol.y(2,:))
%  %xlabel('R(t)');
%  %ylabel('P(t)');
% function v = hepat1h(t)
% v = [0.1 0.1];
% %---------------------------------------------
% function dy = hepat1f(t,y,Z)
%  gm = 1;
%  k = 0.5;
%  n =3;
%  alpha1 = 1;
%  alpha2 = 1;
%  %------------------------------------------------
% ylag1 = Z(:,1);  
% dy = [gm /(1+(ylag1(1)/k)^n) - alpha1*y(2);
%      y(1) - alpha2*y(2)]



%---5.4.7---Cargo Pendulation Reduction Problem-----%
%---Figure5.10---%

% function sol = DDE_one
% sol = dde23(@DDE_onef,12,@hepat1h,[0, 300]);
%  figure
%  hold on;
%  plot(sol.x,sol.y(1,:))
%  xlabel('t-Time');
%  ylabel('x(t)');
% function v = hepat1h(t)
% v = [1.0 0];
% %---------------------------------------------
% function dy = DDE_onef(t,y,Z)
% epsilon = 0.1;
% k = -0.15;
%  %------------------------------------------------
% ylag1 = Z(:,1);  
% dy = [y(2); 
%      -epsilon*y(2)-sin(y(1))-k*cos(y(1))*(ylag1(1)-y(1))];
 


