(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    161053,       4188]
NotebookOptionsPosition[    157010,       4057]
NotebookOutlinePosition[    157434,       4073]
CellTagsIndexPosition[    157391,       4070]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Population", " ", "Model", " ", "involving", " ", "growth", " ", 
    RowBox[{"(", 
     RowBox[{"2.3", ".1"}], ")"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"RSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{"a", "[", "n", "]"}], " ", "-", " ", 
         RowBox[{"0.03", " ", 
          RowBox[{"a", "[", "n", "]"}]}]}]}], " ", ",", 
       RowBox[{
        RowBox[{"a", "[", "0", "]"}], "\[Equal]", "150"}]}], "}"}], ",", " ", 
     "a", ",", "n"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"cc1", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"a", "[", "n", "]"}], "/.", 
        RowBox[{"First", "[", "%", "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "0", ",", "165"}], "}"}]}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"ListPlot", "[", 
    RowBox[{"cc1", ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotMarkers", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Automatic", ",", "Small"}], "}"}]}], ",", " ", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"AxesOrigin", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Black"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Time", " ", ",", "\"\<Number of Tigers\>\""}], "}"}]}], ",", 
     " ", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "19"}]}], "}"}]}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5772433107126884`*^9, 3.57724331825712*^9}, {
  3.577243690518412*^9, 3.577243825055107*^9}, {3.57724388751868*^9, 
  3.5772439438439016`*^9}, {3.577245231791568*^9, 3.5772452330626407`*^9}, {
  3.5804073323844924`*^9, 3.580407332472498*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"a", "\[Rule]", 
    RowBox[{"Function", "[", 
     RowBox[{
      RowBox[{"{", "n", "}"}], ",", 
      RowBox[{"150.`", " ", 
       SuperscriptBox["1.0309278350515463`", 
        RowBox[{
         RowBox[{"-", "1.`"}], " ", "n"}]]}]}], "]"}]}], "}"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.5772438065060463`*^9, 3.5772438268592105`*^9}, {
   3.5772438897448072`*^9, 3.5772439449399643`*^9}, 3.577245248769539*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "150.`", ",", "145.5`", ",", "141.13500000000002`", ",", 
   "136.90095000000005`", ",", "132.79392150000007`", ",", 
   "128.81010385500008`", ",", "124.94580073935009`", ",", 
   "121.19742671716959`", ",", "117.56150391565453`", ",", 
   "114.03465879818489`", ",", "110.61361903423936`", ",", 
   "107.29521046321219`", ",", "104.07635414931582`", ",", 
   "100.95406352483637`", ",", "97.92544161909129`", ",", 
   "94.98767837051855`", ",", "92.13804801940302`", ",", "89.37390657882094`",
    ",", "86.69268938145632`", ",", "84.09190870001264`", ",", 
   "81.56915143901227`", ",", "79.1220768958419`", ",", "76.74841458896665`", 
   ",", "74.44596215129766`", ",", "72.21258328675874`", ",", 
   "70.04620578815599`", ",", "67.94481961451132`", ",", "65.90647502607598`",
    ",", "63.92928077529371`", ",", "62.0114023520349`", ",", 
   "60.15106028147387`", ",", "58.34652847302966`", ",", "56.59613261883877`",
    ",", "54.898248640273614`", ",", "53.25130118106541`", ",", 
   "51.65376214563346`", ",", "50.104149281264455`", ",", 
   "48.60102480282652`", ",", "47.142994058741735`", ",", 
   "45.72870423697949`", ",", "44.35684310987011`", ",", "43.02613781657401`",
    ",", "41.73535368207679`", ",", "40.48329307161449`", ",", 
   "39.268794279466064`", ",", "38.09073045108209`", ",", 
   "36.948008537549626`", ",", "35.83956828142314`", ",", 
   "34.76438123298045`", ",", "33.72144979599104`", ",", "32.70980630211131`",
    ",", "31.728512113047977`", ",", "30.776656749656542`", ",", 
   "29.85335704716685`", ",", "28.957756335751846`", ",", 
   "28.089023645679294`", ",", "27.24635293630892`", ",", 
   "26.428962348219653`", ",", "25.636093477773066`", ",", 
   "24.867010673439875`", ",", "24.121000353236685`", ",", 
   "23.397370342639586`", ",", "22.695449232360403`", ",", 
   "22.01458575538959`", ",", "21.354148182727908`", ",", 
   "20.71352373724607`", ",", "20.09211802512869`", ",", 
   "19.489354484374832`", ",", "18.904673849843586`", ",", 
   "18.337533634348283`", ",", "17.787407625317837`", ",", 
   "17.253785396558303`", ",", "16.736171834661555`", ",", 
   "16.23408667962171`", ",", "15.747064079233063`", ",", 
   "15.274652156856071`", ",", "14.816412592150389`", ",", 
   "14.37192021438588`", ",", "13.940762607954305`", ",", 
   "13.522539729715676`", ",", "13.116863537824209`", ",", 
   "12.723357631689485`", ",", "12.341656902738801`", ",", 
   "11.971407195656639`", ",", "11.61226497978694`", ",", 
   "11.263897030393334`", ",", "10.925980119481533`", ",", 
   "10.59820071589709`", ",", "10.280254694420178`", ",", 
   "9.971847053587572`", ",", "9.672691641979947`", ",", "9.38251089272055`", 
   ",", "9.101035565938934`", ",", "8.828004498960768`", ",", 
   "8.563164363991945`", ",", "8.306269433072188`", ",", "8.057081350080022`",
    ",", "7.815368909577622`", ",", "7.580907842290295`", ",", 
   "7.353480607021586`", ",", "7.13287618881094`", ",", "6.918889903146613`", 
   ",", "6.7113232060522146`", ",", "6.50998350987065`", ",", 
   "6.314684004574531`", ",", "6.125243484437296`", ",", "5.941486179904177`",
    ",", "5.763241594507052`", ",", "5.590344346671841`", ",", 
   "5.422634016271687`", ",", "5.259954995783537`", ",", "5.102156345910031`",
    ",", "4.949091655532731`", ",", "4.800618905866749`", ",", 
   "4.6566003386907475`", ",", "4.516902328530025`", ",", 
   "4.381395258674125`", ",", "4.249953400913902`", ",", "4.122454798886485`",
    ",", "3.9987811549198913`", ",", "3.8788177202722944`", ",", 
   "3.762453188664126`", ",", "3.6495795930042028`", ",", 
   "3.5400922052140773`", ",", "3.4338894390576553`", ",", 
   "3.3308727558859257`", ",", "3.2309465732093487`", ",", 
   "3.1340181760130688`", ",", "3.039997630732677`", ",", 
   "2.9487977018106966`", ",", "2.860333770756376`", ",", 
   "2.774523757633685`", ",", "2.6912880449046748`", ",", 
   "2.610549403557535`", ",", "2.532232921450809`", ",", "2.456265933807285`",
    ",", "2.3825779557930664`", ",", "2.311100617119275`", ",", 
   "2.241767598605697`", ",", "2.1745145706475264`", ",", 
   "2.1092791335281005`", ",", "2.046000759522258`", ",", 
   "1.9846207367365905`", ",", "1.925082114634493`", ",", 
   "1.8673296511954585`", ",", "1.8113097616595948`", ",", 
   "1.7569704688098071`", ",", "1.704261354745513`", ",", 
   "1.6531335141031478`", ",", "1.6035395086800535`", ",", 
   "1.5554333234196522`", ",", "1.5087703237170629`", ",", 
   "1.463507214005551`", ",", "1.4196019975853846`", ",", 
   "1.3770139376578232`", ",", "1.3357035195280889`", ",", 
   "1.2956324139422462`", ",", "1.256763441523979`", ",", 
   "1.2190605382782598`", ",", "1.182488722129912`", ",", 
   "1.1470140604660146`", ",", "1.1126036386520344`", ",", 
   "1.0792255294924735`", ",", "1.0468487636076995`", ",", 
   "1.0154433006994685`", ",", "0.9849800016784845`"}], "}"}]], "Output",
 CellChangeTimes->{{3.5772438065060463`*^9, 3.5772438268592105`*^9}, {
   3.5772438897448072`*^9, 3.5772439449399643`*^9}, 3.5772452487735395`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Newton", "'"}], "s", " ", "Law", " ", "of", " ", "Cooling", " ", 
    RowBox[{"(", 
     RowBox[{"2.3", ".2"}], ")"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"RSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"11.", "/", "12"}], ")"}], 
          RowBox[{"a", "[", "n", "]"}]}], " ", "+", " ", 
         RowBox[{"70", "/", "12"}]}]}], " ", ",", 
       RowBox[{
        RowBox[{"a", "[", "0", "]"}], "\[Equal]", "190"}]}], "}"}], ",", " ", 
     "a", ",", "n"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"cc2", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"a", "[", "n", "]"}], "/.", 
        RowBox[{"First", "[", "%", "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "0", ",", "100"}], "}"}]}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"ListPlot", "[", 
    RowBox[{"cc2", ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotMarkers", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Automatic", ",", "Small"}], "}"}]}], ",", " ", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"AxesOrigin", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Black"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Time", " ", ",", "\"\<Temperature\>\""}], "}"}]}], ",", " ", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "19"}]}], "}"}]}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5772542197856517`*^9, 3.57725424615116*^9}, {
  3.577254302392377*^9, 3.5772544505078487`*^9}, {3.5772776984816027`*^9, 
  3.5772777123153934`*^9}, {3.580407336399722*^9, 3.580407336488727*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"a", "\[Rule]", 
    RowBox[{"Function", "[", 
     RowBox[{
      RowBox[{"{", "n", "}"}], ",", 
      RowBox[{"35.`", " ", 
       SuperscriptBox["1.0909090909090908`", 
        RowBox[{
         RowBox[{"-", "1.`"}], " ", "n"}]], " ", 
       SuperscriptBox["2.`", 
        RowBox[{
         RowBox[{"-", "2.`"}], " ", "n"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"5.428571428571429`", " ", 
          SuperscriptBox["2.`", 
           RowBox[{"2.`", " ", "n"}]]}], "+", 
         RowBox[{"2.`", " ", 
          SuperscriptBox["1.0909090909090908`", 
           RowBox[{"1.`", " ", "n"}]], " ", 
          SuperscriptBox["2.`", 
           RowBox[{"2.`", " ", "n"}]]}], "-", 
         RowBox[{"2.`", " ", 
          SuperscriptBox["1.0909090909090908`", 
           RowBox[{"1.`", " ", "n"}]], " ", 
          SuperscriptBox["3.6666666666666665`", "n"]}]}], ")"}]}]}], "]"}]}], 
   "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.577254323795601*^9, 3.577254453153*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "190.`", ",", "180.00000000000003`", ",", "170.83333333333334`", ",", 
   "162.43055555555557`", ",", "154.72800925925932`", ",", 
   "147.66734182098773`", ",", "141.19506333590542`", ",", 
   "135.26214139124664`", ",", "129.8236296086428`", ",", 
   "124.83832714125589`", ",", "120.26846654615123`", ",", 
   "116.0794276673053`", ",", "112.23947536169652`", ",", 
   "108.71951908155515`", ",", "105.49289249142556`", ",", 
   "102.53515145047342`", ",", "99.82388882960066`", ",", 
   "97.33856476046729`", ",", "95.06035103042834`", ",", "92.97198844455932`",
    ",", "91.05765607417939`", ",", "89.30285140133111`", ",", 
   "87.69428045122018`", ",", "86.21975708028518`", ",", "84.86811065692808`",
    ",", "83.6291014355174`", ",", "82.49334298255764`", ",", 
   "81.4522310673445`", ",", "80.49787847839912`", ",", "79.62305527186585`", 
   ",", "78.82113399921036`", ",", "78.08603949927618`", ",", 
   "77.4122028743365`", ",", "76.79451930147512`", ",", "76.22830935968553`", 
   ",", "75.70928357971172`", ",", "75.23350994806908`", ",", 
   "74.79738411906332`", ",", "74.3976021091414`", ",", "74.03113526671295`", 
   ",", "73.6952073278202`", ",", "73.38727338383518`", ",", 
   "73.10500060184893`", ",", "72.84625055169484`", ",", "72.60906300572027`",
    ",", "72.39164108857692`", ",", "72.19233766452884`", ",", 
   "72.00964285915144`", ",", "71.8421726208888`", ",", "71.68865823581474`", 
   ",", "71.54793671616352`", ",", "71.41894198981655`", ",", 
   "71.3006968239985`", ",", "71.19230542199863`", ",", "71.09294663683207`", 
   ",", "71.0018677504294`", ",", "70.91837877122695`", ",", 
   "70.84184720695804`", ",", "70.77169327304489`", ",", "70.70738550029112`",
    ",", "70.64843670860022`", ",", "70.59440031621685`", ",", 
   "70.54486695653212`", ",", "70.49946137682112`", ",", "70.45783959541936`",
    ",", "70.41968629580107`", ",", "70.38471243781765`", ",", 
   "70.35265306799951`", ",", "70.32326531233288`", ",", "70.29632653630514`",
    ",", "70.27163265827971`", ",", "70.24899660342308`", ",", 
   "70.22824688647114`", ",", "70.20922631259855`", ",", "70.19179078654868`",
    ",", "70.17580822100294`", ",", "70.16115753591937`", ",", 
   "70.14772774125943`", ",", "70.13541709615447`", ",", "70.1241323381416`", 
   ",", "70.11378797662981`", ",", "70.10430564524397`", ",", 
   "70.09561350814032`", ",", "70.08764571579529`", ",", "70.08034190614569`",
    ",", "70.07364674730022`", ",", "70.06750951835853`", ",", 
   "70.06188372516198`", ",", "70.05672674806516`", ",", "70.05199951905972`",
    ",", "70.04766622580475`", ",", "70.04369404032101`", ",", 
   "70.04005287029428`", ",", "70.03671513110308`", ",", "70.03365553684449`",
    ",", "70.03085090877411`", ",", "70.0282799997096`", ",", 
   "70.02592333306713`", ",", "70.02376305531153`", ",", "70.02178280070223`",
    ",", "70.01996756731039`"}], "}"}]], "Output",
 CellChangeTimes->{{3.577254323795601*^9, 3.5772544531569996`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Bank", " ", "Account", " ", "Problem", " ", 
    RowBox[{"(", 
     RowBox[{"2.3", ".3"}], ")"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"RSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{"1.04", " ", 
          RowBox[{"a", "[", "n", "]"}]}], " ", "-", " ", "2000"}]}], ",", 
       RowBox[{
        RowBox[{"a", "[", "0", "]"}], "\[Equal]", "40000"}]}], "}"}], ",", 
     " ", "a", ",", "n"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"cc", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"a", "[", "n", "]"}], "/.", 
        RowBox[{"First", "[", "%", "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "0", ",", "41"}], "}"}]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.534670650015625*^9, 3.534670744609375*^9}, {
  3.534670786625*^9, 3.534670796296875*^9}, {3.5368330068125*^9, 
  3.53683300846875*^9}, {3.5772432925556498`*^9, 3.5772433000010757`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"a", "\[Rule]", 
    RowBox[{"Function", "[", 
     RowBox[{
      RowBox[{"{", "n", "}"}], ",", 
      RowBox[{"0.9615384615384615`", " ", 
       SuperscriptBox["2.718281828459045`", 
        RowBox[{
         RowBox[{"-", "0.03922071315328133`"}], " ", "n"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"51999.99999999995`", " ", 
          SuperscriptBox["1.04`", "n"]}], "-", 
         RowBox[{"10399.999999999949`", " ", 
          SuperscriptBox["1.04`", "n"], " ", 
          SuperscriptBox["2.718281828459045`", 
           RowBox[{"0.03922071315328133`", " ", "n"}]]}]}], ")"}]}]}], 
     "]"}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.536832102046875*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "40000.`", ",", "39599.99999999999`", ",", "39184.`", ",", "38751.36`", ",",
    "38301.4144`", ",", "37833.470976`", ",", "37346.80981504002`", ",", 
   "36840.682207641614`", ",", "36314.309495947266`", ",", 
   "35766.88187578516`", ",", "35197.557150816574`", ",", 
   "34605.45943684925`", ",", "33989.677814323215`", ",", 
   "33349.26492689615`", ",", "32683.235523972002`", ",", 
   "31990.56494493087`", ",", "31270.187542728105`", ",", 
   "30520.995044437233`", ",", "29741.834846214726`", ",", 
   "28931.508240063326`", ",", "28088.768569665845`", ",", 
   "27212.319312452488`", ",", "26300.812084950583`", ",", 
   "25352.844568348606`", ",", "24366.958351082558`", ",", 
   "23341.63668512586`", ",", "22275.302152530887`", ",", 
   "21166.314238632138`", ",", "20012.96680817742`", ",", 
   "18813.485480504518`", ",", "17566.024899724696`", ",", 
   "16268.66589571369`", ",", "14919.412531542239`", ",", 
   "13516.189032803932`", ",", "12056.836594116085`", ",", 
   "10539.110057880727`", ",", "8960.67446019595`", ",", "7319.101438603795`",
    ",", "5611.865496147953`", ",", "3836.3401159938703`", ",", 
   "1989.7937206336264`", ",", "69.38546945898028`"}], "}"}]], "Output",
 CellChangeTimes->{3.536832102046875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"RSolve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"1.04", " ", 
        RowBox[{"a", "[", "n", "]"}]}], " ", "-", " ", "2000"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", "0", "]"}], "\[Equal]", "60000"}]}], "}"}], ",", " ", 
   "a", ",", "n"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"dd", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"a", "[", "n", "]"}], "/.", 
      RowBox[{"First", "[", "%", "]"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "0", ",", "41"}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.534670806671875*^9, 3.534670810125*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"a", "\[Rule]", 
    RowBox[{"Function", "[", 
     RowBox[{
      RowBox[{"{", "n", "}"}], ",", 
      RowBox[{"0.9615384615384615`", " ", 
       SuperscriptBox["2.718281828459045`", 
        RowBox[{
         RowBox[{"-", "0.03922071315328133`"}], " ", "n"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"51999.99999999995`", " ", 
          SuperscriptBox["1.04`", "n"]}], "+", 
         RowBox[{"10400.000000000051`", " ", 
          SuperscriptBox["1.04`", "n"], " ", 
          SuperscriptBox["2.718281828459045`", 
           RowBox[{"0.03922071315328133`", " ", "n"}]]}]}], ")"}]}]}], 
     "]"}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.53683210325*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "59999.99999999999`", ",", "60399.99999999999`", ",", "60816.00000000001`", 
   ",", "61248.63999999999`", ",", "61698.585600000006`", ",", 
   "62166.529024`", ",", "62653.19018496002`", ",", "63159.317792358415`", 
   ",", "63685.69050405275`", ",", "64233.11812421485`", ",", 
   "64802.442849183455`", ",", "65394.540563150804`", ",", 
   "66010.32218567685`", ",", "66650.73507310392`", ",", "67316.76447602808`",
    ",", "68009.43505506919`", ",", "68729.81245727197`", ",", 
   "69479.00495556285`", ",", "70258.16515378539`", ",", "71068.4917599368`", 
   ",", "71911.23143033426`", ",", "72787.68068754765`", ",", 
   "73699.18791504954`", ",", "74647.15543165152`", ",", "75633.04164891758`",
    ",", "76658.36331487431`", ",", "77724.69784746926`", ",", 
   "78833.68576136805`", ",", "79987.03319182277`", ",", "81186.5145194957`", 
   ",", "82433.97510027552`", ",", "83731.33410428656`", ",", 
   "85080.587468458`", ",", "86483.81096719633`", ",", "87943.16340588419`", 
   ",", "89460.88994211957`", ",", "91039.32553980435`", ",", 
   "92680.89856139649`", ",", "94388.13450385239`", ",", "96163.65988400648`",
    ",", "98010.20627936676`", ",", "99930.61453054142`"}], "}"}]], "Output",
 CellChangeTimes->{3.536832103265625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"RSolve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"1.04", " ", 
        RowBox[{"a", "[", "n", "]"}]}], " ", "-", " ", "2000"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", "0", "]"}], "\[Equal]", "50000"}]}], "}"}], ",", " ", 
   "a", ",", "n"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"ee", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"a", "[", "n", "]"}], "/.", 
      RowBox[{"First", "[", "%", "]"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "0", ",", "41"}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.534670871765625*^9, 3.5346708785625*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"a", "\[Rule]", 
    RowBox[{"Function", "[", 
     RowBox[{
      RowBox[{"{", "n", "}"}], ",", 
      RowBox[{"0.9615384615384615`", " ", 
       SuperscriptBox["2.718281828459045`", 
        RowBox[{
         RowBox[{"-", "0.03922071315328133`"}], " ", "n"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"51999.99999999995`", " ", 
          SuperscriptBox["1.04`", "n"]}], "+", 
         RowBox[{"5.093170329928398`*^-11", " ", 
          SuperscriptBox["1.04`", "n"], " ", 
          SuperscriptBox["2.718281828459045`", 
           RowBox[{"0.03922071315328133`", " ", "n"}]]}]}], ")"}]}]}], 
     "]"}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.53683210434375*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "49999.99999999999`", ",", "49999.99999999999`", ",", "50000.`", ",", 
   "50000.`", ",", "50000.00000000001`", ",", "50000.`", ",", 
   "50000.00000000002`", ",", "50000.000000000015`", ",", 
   "50000.000000000015`", ",", "50000.00000000001`", ",", 
   "50000.000000000015`", ",", "50000.00000000002`", ",", 
   "50000.00000000003`", ",", "50000.00000000003`", ",", "50000.00000000004`",
    ",", "50000.00000000003`", ",", "50000.00000000003`", ",", 
   "50000.00000000004`", ",", "50000.00000000005`", ",", 
   "50000.000000000065`", ",", "50000.00000000005`", ",", 
   "50000.000000000065`", ",", "50000.000000000065`", ",", 
   "50000.000000000065`", ",", "50000.000000000065`", ",", 
   "50000.00000000007`", ",", "50000.00000000007`", ",", "50000.0000000001`", 
   ",", "50000.0000000001`", ",", "50000.00000000011`", ",", 
   "50000.0000000001`", ",", "50000.00000000013`", ",", "50000.000000000124`",
    ",", "50000.000000000124`", ",", "50000.00000000013`", ",", 
   "50000.00000000014`", ",", "50000.00000000015`", ",", 
   "50000.000000000146`", ",", "50000.00000000017`", ",", 
   "50000.00000000018`", ",", "50000.00000000019`", ",", 
   "50000.0000000002`"}], "}"}]], "Output",
 CellChangeTimes->{3.53683210434375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"cc", ",", "dd", ",", "ee"}], "}"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotMarkers", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Automatic", ",", "Small"}], "}"}]}], ",", " ", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Black", ",", "Black", ",", "Black"}], "}"}]}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Time", " ", ",", "\"\<Amount in Rupees\>\""}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.534670750796875*^9, 3.53467076421875*^9}, {
  3.5346708165625*^9, 3.534670825296875*^9}, {3.53467088615625*^9, 
  3.534670889765625*^9}, {3.536830448875*^9, 3.536830449734375*^9}, {
  3.53683050146875*^9, 3.536830524796875*^9}, {3.536830916625*^9, 
  3.5368309713125*^9}, {3.536894069765625*^9, 3.5368940705*^9}, {
  3.536894101703125*^9, 3.53689410475*^9}}],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJxd1H9M1HUcx3F+2EIZRNednHDQdUfHBQTHHRzcL+51d5DUEU4UBpTTXKhE
A8OVxKS02UBzbKwfOMtJCyxFruzUXMksBamYigeoGeod/SIYQsLpUSkd8v64
vt/v9t1nj+/zu+9fr30fW1tVUBYUEBDwhv+eO+evSfO9o+EX0APMzl2FzCHz
p4w5AgXHY98eGxsmCzHxw2lrh5NZjP1WoyDldWYJFhsCR0uMzFJ8Hds2ILrj
IctQE/riH09/wxyHsKYVmUOvMSuwYOrJgcMpzErYRo44Hb+5yQm4fuDTL47u
Zk5CiW9p7We5zMmwy/sF50evk1Vo+D5c2WpiTsW01hmwa8c1shqzQ+cc5nNX
yRo8fyG28tVQ5jS0rAysd2OInA63K0uVWvkzWYsn3txbJXz3CjkDIqVmRvP5
T+RMSNdvCNOeukzWoaJnX2Fn7yWyHs/5qk9u6L1INqC1aXNR/7eDZCNCS7dI
3msfIJswvD7FbXqnn5yFjS6JYPVqF9mMvmBv87b4C2TgZYnAWHjm/Ly3Alll
g2ePyM9St+CFSL1avO5H6hbki7eLKnb1ULdCXbFmceP7XdStCFEfW1m09Tvq
NlxZ5bm9pPkEdRuecsU3XR07Sj0bi+445A5fB/VsFIdHdSdF7qOeg6J/Ihva
i5eTJ8339mgfJ9M+65hDEDh3fMkcgY6lnlrhCLMQAq2xs0B6gyxGaefp8b5S
Zgkmuu6K9jczS/GMpzRx9CKzDDunPxQfE0+Q4+CtPNQjX8WsQECYKzG/lVmJ
rkh73vIbzAkQJR6Kb4uZJCfhcvDQqfYc5mRoMuyGvCpmFYaf/df7wR7mVOSq
+2c/6mFW40xunnDjLWYNDttrWmXxf5HT4DlovtZTwpyOZfZJ56ZGZi3MLeJf
9d3MGQjWOgM1d5kzYfm9bUu17iZZh5Tw3QcjNjPr4bXI+x7/itmAj6PXJvTO
MBux80+3L8o8RTZBpJiuV9UzZ2FTb41B6WI2I/pk0J5HpdNkYPuJuuL0V8j+
fZavyFm3o5t1CxSdx2eMMV7qFiysW7a3uobs36fjpsaUf4l1KwZ05ele3S3q
NmhHt61pbCH79zn11rjCGnqbejZUDcON+lqyf5+e5rG8T8ZZz0HM3zGDB8p8
ZNpn+QiZ9nnf9P98iTmCZ+H8fu9bzOsSBHMsRRDHMp7jeN9T8LqS970ELOA4
iedkPMCxitdTeVbz3tfgQY7TsJDjdF7X8noGz5k863jWYxHHBp6NCOfYxHMW
HuLYzOuA4P/27/NhTrdw7d8n533/Ph/hdCtEnG6DkNNtiOT0bCzh9GxEcXoO
osn/ARU74rA=
   "], {{{}, {}, 
     {GrayLevel[0], 
      LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 
       19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36,
        37, 38, 39, 40, 41, 42}]}, 
     {GrayLevel[0], 
      LineBox[{43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58,
        59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 
       76, 77, 78, 79, 80, 81, 82, 83, 84}]}, 
     {GrayLevel[0], 
      LineBox[{85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 
       100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 
       114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 124, 125, 126}]}}, {
     {GrayLevel[0], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 1], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 2], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 3], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 4], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 5], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 6], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 7], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 8], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 9], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 10], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 11], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 12], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 13], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 14], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 15], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 16], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 17], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 18], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 19], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 20], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 21], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 22], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 23], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 24], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 25], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 26], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 27], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 28], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 29], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 30], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 31], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 32], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 33], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 34], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 35], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 36], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 37], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 38], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 39], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 40], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 41], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 42]}, 
     {GrayLevel[0], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 43], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 44], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 45], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 46], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 47], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 48], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 49], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 50], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 51], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 52], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 53], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 54], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 55], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 56], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 57], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 58], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 59], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 60], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 61], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 62], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 63], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 64], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 65], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 66], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 67], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 68], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 69], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 70], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 71], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 72], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 73], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 74], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 75], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 76], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 77], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 78], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 79], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 80], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 81], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 82], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 83], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 84]}, 
     {GrayLevel[0], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 85], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 86], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 87], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 88], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 89], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 90], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 91], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 92], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 93], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 94], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 95], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 96], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 97], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 98], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 99], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 100], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 101], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 102], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 103], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 104], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 105], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 106], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 107], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 108], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 109], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 110], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 111], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 112], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 113], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 114], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 115], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 116], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 117], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 118], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 119], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 120], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 121], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 122], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 123], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 124], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 125], InsetBox[
       StyleBox["\<\"\[FilledDiamond]\"\>",
        StripOnInput->False,
        FontSize->Small], 126]}, {}}}],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{
    FormBox["Time", TraditionalForm], 
    FormBox[
     RowBox[{"Amount", " ", "in", " ", "Rupees"}], TraditionalForm]},
  AxesOrigin->{0, 0},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.536832105375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Drug", " ", "Delivery", " ", "Problem", " ", "2.3", ".4"}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"RSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{"0.5", 
          RowBox[{"a", "[", "n", "]"}]}], " ", "+", " ", "0.2"}]}], ",", 
       RowBox[{
        RowBox[{"a", "[", "0", "]"}], "\[Equal]", "1.0"}]}], "}"}], ",", " ", 
     "a", ",", "n"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"aa", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"a", "[", "n", "]"}], "/.", 
        RowBox[{"First", "[", "%", "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "0", ",", "15"}], "}"}]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.53466786803125*^9, 3.534667889625*^9}, {
  3.53466798178125*^9, 3.53466803103125*^9}, {3.534668194671875*^9, 
  3.534668207*^9}, {3.534668396125*^9, 3.53466839746875*^9}, {
  3.534668586125*^9, 3.534668596796875*^9}, {3.5346690884375*^9, 
  3.534669089140625*^9}, {3.534669309953125*^9, 3.534669330703125*^9}, {
  3.534669624109375*^9, 3.534669665546875*^9}, {3.53466975440625*^9, 
  3.534669757796875*^9}, {3.5368328425625*^9, 3.536832859671875*^9}, {
  3.536833016265625*^9, 3.536833020953125*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"a", "\[Rule]", 
    RowBox[{"Function", "[", 
     RowBox[{
      RowBox[{"{", "n", "}"}], ",", 
      RowBox[{
       SuperscriptBox["2.`", 
        RowBox[{
         RowBox[{"-", "1.`"}], " ", "n"}]], " ", 
       RowBox[{"(", 
        RowBox[{"0.6`", "\[InvisibleSpace]", "+", 
         RowBox[{"0.4`", " ", 
          SuperscriptBox["2.718281828459045`", 
           RowBox[{"0.6931471805599453`", " ", "n"}]]}]}], ")"}]}]}], "]"}]}],
    "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.534667874546875*^9, 3.534667892046875*^9}, {
   3.53466800303125*^9, 3.5346680325625*^9}, {3.534668185171875*^9, 
   3.53466820790625*^9}, 3.534668401609375*^9, {3.53466858784375*^9, 
   3.534668597734375*^9}, 3.53466882659375*^9, 3.53466909925*^9, 
   3.5346691605*^9, {3.53466931178125*^9, 3.534669331859375*^9}, 
   3.534669451875*^9, 3.534669643875*^9, 3.5346696750625*^9, 
   3.534669730828125*^9, 3.534669767765625*^9, 3.536832002765625*^9, 
   3.53683225196875*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1.`", ",", "0.7`", ",", "0.5499999999999999`", ",", "0.4749999999999999`", 
   ",", "0.4374999999999999`", ",", "0.4187499999999999`", ",", 
   "0.4093749999999998`", ",", "0.4046874999999998`", ",", 
   "0.40234374999999983`", ",", "0.40117187499999984`", ",", 
   "0.40058593749999993`", ",", "0.4002929687499999`", ",", 
   "0.40014648437499956`", ",", "0.40007324218749957`", ",", 
   "0.4000366210937496`", ",", "0.40001831054687464`"}], "}"}]], "Output",
 CellChangeTimes->{{3.534667874546875*^9, 3.534667892046875*^9}, {
   3.53466800303125*^9, 3.5346680325625*^9}, {3.534668185171875*^9, 
   3.53466820790625*^9}, 3.534668401609375*^9, {3.53466858784375*^9, 
   3.534668597734375*^9}, 3.53466882659375*^9, 3.53466909925*^9, 
   3.5346691605*^9, {3.53466931178125*^9, 3.534669331859375*^9}, 
   3.534669451875*^9, 3.534669643875*^9, 3.5346696750625*^9, 
   3.534669730828125*^9, 3.534669767765625*^9, 3.536832002765625*^9, 
   3.53683225196875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"RSolve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"0.5", 
        RowBox[{"a", "[", "n", "]"}]}], " ", "+", " ", "0.2"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", "0", "]"}], "\[Equal]", "0.1"}]}], "}"}], ",", " ", 
   "a", ",", "n"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"bb", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"a", "[", "n", "]"}], "/.", 
      RowBox[{"First", "[", "%", "]"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "0", ",", "15"}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.534669659*^9, 3.53466967134375*^9}, {
  3.534669712984375*^9, 3.534669713640625*^9}, {3.534669760515625*^9, 
  3.53466976125*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"a", "\[Rule]", 
    RowBox[{"Function", "[", 
     RowBox[{
      RowBox[{"{", "n", "}"}], ",", 
      RowBox[{
       SuperscriptBox["2.`", 
        RowBox[{
         RowBox[{"-", "1.`"}], " ", "n"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "0.30000000000000004`"}], "+", 
         RowBox[{"0.4`", " ", 
          SuperscriptBox["2.718281828459045`", 
           RowBox[{"0.6931471805599453`", " ", "n"}]]}]}], ")"}]}]}], "]"}]}],
    "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.53466967984375*^9, {3.534669714609375*^9, 3.5346697328125*^9}, 
   3.534669770828125*^9, 3.536832014015625*^9, 3.536832253015625*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.09999999999999998`", ",", "0.24999999999999994`", ",", 
   "0.32499999999999996`", ",", "0.36249999999999993`", ",", 
   "0.3812499999999999`", ",", "0.3906249999999999`", ",", 
   "0.3953124999999998`", ",", "0.3976562499999998`", ",", 
   "0.39882812499999987`", ",", "0.39941406249999983`", ",", 
   "0.3997070312499999`", ",", "0.39985351562499993`", ",", 
   "0.3999267578124996`", ",", "0.39996337890624956`", ",", 
   "0.39998168945312457`", ",", "0.39999084472656216`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.53466967984375*^9, {3.534669714609375*^9, 3.5346697328125*^9}, 
   3.534669770828125*^9, 3.536832014015625*^9, 3.53683225303125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"aa", ",", "bb"}], "}"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotMarkers", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Automatic", ",", "Small"}], "}"}]}], ",", " ", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Black", ",", "Black"}], "}"}]}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Time", ",", "\"\<Drug amount in the blood\>\""}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.534668377328125*^9, 3.534668432578125*^9}, 
   3.5346686944375*^9, {3.534668862703125*^9, 3.534668895125*^9}, {
   3.53466901878125*^9, 3.5346690578125*^9}, {3.534669128359375*^9, 
   3.53466913028125*^9}, 3.534669356515625*^9, {3.534669494296875*^9, 
   3.534669504203125*^9}, {3.534669687578125*^9, 3.5346696970625*^9}, {
   3.5346697873125*^9, 3.534669791796875*^9}, {3.534669827828125*^9, 
   3.53466985665625*^9}, {3.5346699124375*^9, 3.534669934125*^9}, 
   3.534670411421875*^9, {3.536832185859375*^9, 3.536832246765625*^9}, {
   3.536832367078125*^9, 3.536832374546875*^9}, {3.536832479609375*^9, 
   3.53683250234375*^9}, {3.5804073146934805`*^9, 3.580407315500527*^9}}],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJxTTMoPSmViYGBQAGIQDQEf7FFpBoc0MHgG5XM4zASDh1C+gEMqWP4elC/i
8O8/CNyG8iUcTp8BgVtQvoyDgTEIwPgKDslg429C+UoOf0Ha98P4Kg6nQNrX
wPhqDkYg7YthfA2I/fNgfC2HHyD9s2F8HYejIP2zYHw9Bx2QfjjfwCEBZP3M
m3B/zwD7byfc/xD/nIf7H+ydM1fg/ge7x/g63P+Q8LgB9z9E/w24/0+CtPvc
hPsfHB7FCP+ngLS3IfwPDo9+hP/B4TkF4X+w/dMR/o8H6Z+B8D84PGYg/A8K
D5+ZCP/rgqwH8gE4eqCG
   "], {{{}, {}, 
     {GrayLevel[0], 
      LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16}]}, 
     {GrayLevel[0], 
      LineBox[{17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 
       32}]}}, {
     {GrayLevel[0], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 1], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 2], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 3], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 4], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 5], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 6], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 7], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 8], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 9], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 10], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 11], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 12], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 13], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 14], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 15], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 16]}, 
     {GrayLevel[0], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 17], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 18], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 19], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 20], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 21], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 22], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 23], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 24], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 25], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 26], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 27], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 28], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 29], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 30], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 31], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 32]}, {}}}],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{
    FormBox["Time", TraditionalForm], 
    FormBox["\"Drug amount in the blood\"", TraditionalForm]},
  AxesOrigin->{0, 0},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.536832505359375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Arm", " ", "Race", " ", "Model", " ", "2.3", ".6"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"g", " ", "=", " ", "0.6"}], ";", " ", 
    RowBox[{"d", " ", "=", " ", "0.1"}], ";", " ", 
    RowBox[{"k", " ", "=", " ", "100"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"RSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", "g", " ", "+", " ", "d"}], ")"}], 
          RowBox[{"a", "[", "n", "]"}]}], " ", "+", " ", "k"}]}], ",", 
       RowBox[{
        RowBox[{"a", "[", "0", "]"}], "\[Equal]", "5.0"}]}], "}"}], ",", " ", 
     "a", ",", "n"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"cc4", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"a", "[", "n", "]"}], "/.", 
        RowBox[{"First", "[", "%", "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "0", ",", "20"}], "}"}]}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"ListPlot", "[", 
    RowBox[{"cc4", ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotMarkers", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Automatic", ",", "Small"}], "}"}]}], ",", " ", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"AxesOrigin", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Black"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Time", " ", ",", "\"\<Amount Spent (in Crores)\>\""}], 
       "}"}]}], ",", " ", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "19"}]}], "}"}]}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.534834489130375*^9, 3.534834497896*^9}, {
   3.5348345457085*^9, 3.534834547036625*^9}, {3.53483466892725*^9, 
   3.534834676692875*^9}, {3.5348353412085*^9, 3.534835426786625*^9}, {
   3.534838007161625*^9, 3.53483802836475*^9}, {3.534838200755375*^9, 
   3.534838205521*^9}, 3.534838296692875*^9, {3.53483852655225*^9, 
   3.53483852692725*^9}, {3.534838975286625*^9, 3.53483898630225*^9}, {
   3.534839030224125*^9, 3.534839061505375*^9}, {3.53683389821875*^9, 
   3.536833898765625*^9}, {3.53683395028125*^9, 3.5368340020625*^9}, {
   3.577277791785939*^9, 3.5772778057077355`*^9}, {3.577277867690281*^9, 
   3.577277904848406*^9}, {3.577277978942644*^9, 3.5772779795096765`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"a", "\[Rule]", 
    RowBox[{"Function", "[", 
     RowBox[{
      RowBox[{"{", "n", "}"}], ",", 
      RowBox[{"2.5`", " ", 
       SuperscriptBox["2.`", 
        RowBox[{
         RowBox[{"-", "1.`"}], " ", "n"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "78.`"}], "+", 
         RowBox[{"80.`", " ", 
          SuperscriptBox["2.`", "n"]}]}], ")"}]}]}], "]"}]}], "}"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.534835612630375*^9, {3.53483800948975*^9, 3.534838030317875*^9}, 
   3.53483820855225*^9, 3.534838303021*^9, 3.534838528224125*^9, 
   3.5348389877085*^9, {3.534839032224125*^9, 3.534839063771*^9}, 
   3.536834004125*^9, 3.57727780823788*^9, 3.5772779219323835`*^9, 
   3.5772779817518044`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "5.`", ",", "102.5`", ",", "151.25`", ",", "175.625`", ",", "187.8125`", 
   ",", "193.90625`", ",", "196.953125`", ",", "198.4765625`", ",", 
   "199.23828125`", ",", "199.619140625`", ",", "199.8095703125`", ",", 
   "199.90478515625`", ",", "199.952392578125`", ",", "199.9761962890625`", 
   ",", "199.98809814453125`", ",", "199.99404907226562`", ",", 
   "199.9970245361328`", ",", "199.9985122680664`", ",", "199.9992561340332`",
    ",", "199.9996280670166`", ",", "199.9998140335083`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.534835612630375*^9, {3.53483800948975*^9, 3.534838030317875*^9}, 
   3.53483820855225*^9, 3.534838303021*^9, 3.534838528224125*^9, 
   3.5348389877085*^9, {3.534839032224125*^9, 3.534839063771*^9}, 
   3.536834004125*^9, 3.57727780823788*^9, 3.5772779219323835`*^9, 
   3.577277981759805*^9}],

Cell[BoxData[
 GraphicsBox[{{}, GraphicsComplexBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQDQEf7CG0iANUAEIviITyOSD0iyQoXwBCf0l1QNFX
lQ7lS0Bo2wwoXwZMN8yD8RXAtMN5GF8JTC94DuOrgOkLn2F8NTD94ieMrwGm
v/yB8bXAdNU/GF8HTNv+h/H1HMDWw/kGDmDr4XxDB7D1cL6RA9h6ON/YAWw9
nG/iALYezjd1AFsP5AMAaf04/A==
    "], {{{}, {}, 
      {GrayLevel[0], 
       LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18,
         19, 20, 21}]}}, {
      {GrayLevel[0], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 1], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 2], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 3], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 4], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 5], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 6], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 7], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 8], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 9], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 10], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 11], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 12], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 13], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 14], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 15], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 16], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 17], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 18], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 19], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 20], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 21]}, {}}}], {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{
    FormBox["Time", TraditionalForm], 
    FormBox["\"Amount Spent (in Crores)\"", TraditionalForm]},
  AxesOrigin->{0, 0},
  BaseStyle->{FontWeight -> "Bold", FontSize -> 19},
  Method->{},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.534835612630375*^9, {3.53483800948975*^9, 3.534838030317875*^9}, 
   3.53483820855225*^9, 3.534838303021*^9, 3.534838528224125*^9, 
   3.5348389877085*^9, {3.534839032224125*^9, 3.534839063771*^9}, 
   3.536834004125*^9, 3.57727780823788*^9, 3.5772779219323835`*^9, 
   3.5772779817818065`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Linear", " ", "Predator"}], "-", 
    RowBox[{"Prey", " ", "System"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"\[Alpha]", " ", "=", " ", "0.5"}], ";", " ", 
    RowBox[{"\[Beta]", " ", "=", "0.4"}], ";", " ", 
    RowBox[{"\[Gamma]", " ", "=", " ", "0.1"}], ";", " ", 
    RowBox[{"\[Delta]", " ", "=", "0.05"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Eigenvalues", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "-", "\[Alpha]"}], ",", "\[Beta]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "\[Delta]"}], ",", 
        RowBox[{"1", "+", "\[Gamma]"}]}], "}"}]}], "}"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.536894596328125*^9, 3.536894638171875*^9}, {
  3.536894708625*^9, 3.536894736828125*^9}, {3.53689481825*^9, 
  3.536894916296875*^9}, {3.53689523696875*^9, 3.53689523775*^9}, {
  3.5369132838125*^9, 3.53691329421875*^9}, {3.536913733921875*^9, 
  3.53691373734375*^9}, {3.5369149871875*^9, 3.536914988140625*^9}, {
  3.536915019109375*^9, 3.53691503403125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"RSolve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"y", "[", 
       RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"0.5", "  ", 
        RowBox[{"y", "[", "n", "]"}]}], "+", 
       RowBox[{"0.4", " ", 
        RowBox[{"z", "[", "n", "]"}]}]}]}], ",", 
     RowBox[{
      RowBox[{"z", "[", 
       RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "0.17"}], "  ", 
        RowBox[{"y", "[", "n", "]"}]}], "+", 
       RowBox[{"1.1", " ", 
        RowBox[{"z", "[", "n", "]"}]}]}]}], ",", 
     RowBox[{
      RowBox[{"y", "[", "0", "]"}], "\[Equal]", "500"}], ",", 
     RowBox[{
      RowBox[{"z", "[", "0", "]"}], "\[Equal]", "200"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", "z"}], "}"}], ",", " ", "n"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Transpose", " ", "@", " ", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"y", "[", "n", "]"}], ",", 
         RowBox[{"z", "[", "n", "]"}]}], "}"}], "/.", 
       RowBox[{"First", "[", "%", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "0", ",", "30"}], "}"}]}], "]"}]}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotMarkers", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Automatic", ",", "Small"}], "}"}]}], ",", " ", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", "Black", "}"}]}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Time", ",", "\"\<Population\>\""}], "}"}]}], ",", 
   RowBox[{"BaseStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
      RowBox[{"FontSize", "\[Rule]", "19"}]}], "}"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.536854321078125*^9, 3.536854384015625*^9}, {
   3.53685442425*^9, 3.536854425953125*^9}, {3.536854467359375*^9, 
   3.53685450453125*^9}, {3.536854540484375*^9, 3.536854626359375*^9}, {
   3.53685476959375*^9, 3.53685491903125*^9}, {3.53689495271875*^9, 
   3.536894954734375*^9}, {3.53689510825*^9, 3.536895114484375*^9}, {
   3.536895182*^9, 3.536895182546875*^9}, {3.53689521346875*^9, 
   3.53689521484375*^9}, {3.536895300296875*^9, 3.536895350859375*^9}, {
   3.53691318253125*^9, 3.53691318365625*^9}, {3.5369132226875*^9, 
   3.536913223328125*^9}, {3.5369139416875*^9, 3.536913943765625*^9}, {
   3.536913978*^9, 3.536914094765625*^9}, 3.536914209875*^9, {
   3.53691424896875*^9, 3.5369143306875*^9}, {3.536914362140625*^9, 
   3.5369144163125*^9}, {3.536914458828125*^9, 3.53691448534375*^9}, {
   3.536914638265625*^9, 3.536914640484375*^9}, {3.53691494384375*^9, 
   3.536914944546875*^9}, {3.536914999796875*^9, 3.536915000703125*^9}, {
   3.5772818370254087`*^9, 3.5772818881623335`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"y", "\[Rule]", 
     RowBox[{"Function", "[", 
      RowBox[{
       RowBox[{"{", "n", "}"}], ",", 
       RowBox[{
        SuperscriptBox["5.`", 
         RowBox[{
          RowBox[{"-", "2.`"}], " ", "n"}]], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "269.6799449852968`"}], " ", 
           SuperscriptBox["0.6516760302580867`", "n"], " ", 
           SuperscriptBox["5.`", 
            RowBox[{"2.`", " ", "n"}]]}], "+", 
          RowBox[{"269.6799449852968`", " ", 
           SuperscriptBox["0.9483239697419132`", "n"], " ", 
           SuperscriptBox["5.`", 
            RowBox[{"2.`", " ", "n"}]]}], "+", 
          RowBox[{"755.6498968474316`", " ", 
           SuperscriptBox["16.29190075645217`", "n"]}], "-", 
          RowBox[{"255.64989684743153`", " ", 
           SuperscriptBox["23.70809924354783`", "n"]}]}], ")"}]}]}], "]"}]}], 
    ",", 
    RowBox[{"z", "\[Rule]", 
     RowBox[{"Function", "[", 
      RowBox[{
       RowBox[{"{", "n", "}"}], ",", 
       RowBox[{
        SuperscriptBox["5.`", 
         RowBox[{
          RowBox[{"-", "2.`"}], " ", "n"}]], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"286.5349415468779`", " ", 
           SuperscriptBox["0.6516760302580867`", "n"], " ", 
           SuperscriptBox["5.`", 
            RowBox[{"2.`", " ", "n"}]]}], "-", 
          RowBox[{"286.5349415468779`", " ", 
           SuperscriptBox["0.9483239697419132`", "n"], " ", 
           SuperscriptBox["5.`", 
            RowBox[{"2.`", " ", "n"}]]}], "-", 
          RowBox[{"102.25995873897263`", " ", 
           SuperscriptBox["16.29190075645217`", "n"]}], "+", 
          RowBox[{"302.25995873897267`", " ", 
           SuperscriptBox["23.70809924354783`", "n"]}]}], ")"}]}]}], 
      "]"}]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.53685421290625*^9, 3.536854635625*^9, 3.536854675859375*^9, 
   3.536854738859375*^9, {3.5368547718125*^9, 3.53685493240625*^9}, 
   3.5368951224375*^9, {3.53689516421875*^9, 3.53689518521875*^9}, 
   3.536895217453125*^9, 3.536895269375*^9, {3.536895302875*^9, 
   3.536895369078125*^9}, 3.53691318909375*^9, 3.536913237078125*^9, 
   3.53691394778125*^9, {3.5369139813125*^9, 3.536914108078125*^9}, {
   3.5369142119375*^9, 3.536914419484375*^9}, {3.536914451125*^9, 
   3.536914486640625*^9}, {3.53691464271875*^9, 3.53691465428125*^9}, 
   3.536914714625*^9, 3.536914947890625*^9, 3.53691500603125*^9}],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJxF0mlI03Ecx/FpmpuaubS85rE5lqnLY3Nuc26forQnrVRWVkQqidihQWIO
E0kUjal0iGJYHuvSZJpZDcxmd6gP7DBXGihUGCMxScwSSfP7xx/8+fL6P31/
+Bm5yZn2LBZLvfQt35U3rbFbPigG/Vi5TXlkNhyWT9pxsjv8y2xJZm0G2RM6
N3HXVUsq2RttRcoAye+9ZB4W69l+1x4kkoPQMvPRVD0HsgBZptYbPgtyshAn
AlPrAu0kZBHS+T9uDU2JySGwbuvYIssKIYcipdMj1mYQksMRGZzw1WuAT94K
feKfRY4hkBwJs1RQM6fnkaPwvv+C5RLXlxwNa96ewlKeN1mCHUWc4qdnNpGl
uOj4Uyhx3UiOQe6TTEVFvwdZhlcvj2gMtzeQY3H98M7Cg41cshzpU9rJ7W3u
ZAVe+JR/YVWuJyvBCza3nxtfR46Ds4PeZtS6klXIV03MWN85k+Mxo5q38nM4
ZDX8Fr4/nvBjkzXI/9U0YBldS57WrLTPJrPwv/94GpmNhvql57Of7A7XEeOp
eF+mpydKhu4dmJ1PIHvjc8KaApcxpicPKlW7SF2lIAehWOeUfchFShbAKN1l
MyVGkoXgluW1KpPDyCJwenbXltRtJofgoahW93qM6RuKyp595uFBATkcd8T8
pqmI1d6NbQ2nA56t9q5RWDL1l/3JUZi7+eZ5yl0/cjTkWXnGPiemvwQBXdW9
gxVMfykMvKRmzzAvcgx6NZ0foiaZ/jI4ds0Ku3s8ybHQNZpC81uYPchRLkso
FF9h9qCA4hH3PL+Z2YMSuRFHP/29z+whDt/ejhYkdTB7UKG0ajinzNmNHI+R
Y1w357PMHtTonjypLbN3IWtgkRT39jVw8A86UORq
   "], {{{}, {}, 
     {GrayLevel[0], 
      LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 
       19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31}]}, 
     {GrayLevel[0], 
      LineBox[{32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47,
        48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62}]}}, {
     {GrayLevel[0], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 1], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 2], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 3], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 4], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 5], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 6], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 7], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 8], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 9], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 10], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 11], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 12], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 13], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 14], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 15], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 16], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 17], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 18], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 19], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 20], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 21], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 22], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 23], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 24], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 25], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 26], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 27], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 28], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 29], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 30], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 31]}, 
     {GrayLevel[0], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 32], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 33], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 34], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 35], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 36], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 37], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 38], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 39], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 40], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 41], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 42], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 43], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 44], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 45], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 46], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 47], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 48], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 49], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 50], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 51], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 52], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 53], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 54], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 55], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 56], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 57], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 58], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 59], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 60], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 61], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 62]}, {}}}],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{
    FormBox["Time", TraditionalForm], 
    FormBox["\"Population\"", TraditionalForm]},
  AxesOrigin->{0, 0},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.53685421290625*^9, 3.536854635625*^9, 3.536854675859375*^9, 
   3.536854738859375*^9, {3.5368547718125*^9, 3.53685493240625*^9}, 
   3.5368951224375*^9, {3.53689516421875*^9, 3.53689518521875*^9}, 
   3.536895217453125*^9, 3.536895269375*^9, {3.536895302875*^9, 
   3.536895369078125*^9}, 3.53691318909375*^9, 3.536913237078125*^9, 
   3.53691394778125*^9, {3.5369139813125*^9, 3.536914108078125*^9}, {
   3.5369142119375*^9, 3.536914419484375*^9}, {3.536914451125*^9, 
   3.536914486640625*^9}, {3.53691464271875*^9, 3.53691465428125*^9}, 
   3.536914714625*^9, 3.536914947890625*^9, 3.53691500609375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"k", "=", 
   RowBox[{"-", "2"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"tt1", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"Table", "[", " ", 
     RowBox[{
      RowBox[{"k", "^", "n"}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "0", ",", "8"}], "}"}]}], "]"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"PlotMarkers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Automatic", ",", "Small"}], "}"}]}], ",", " ", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"AxesOrigin", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", "Black"}], ",", 
    RowBox[{"AxesLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"n", ",", "\"\<\!\(\*SubscriptBox[\(u\), \(n\)]\)\>\""}], 
      "}"}]}], ",", " ", 
    RowBox[{"PlotLabel", "\[Rule]", "\"\<A\>\""}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
       RowBox[{"FontSize", "\[Rule]", "19"}]}], "}"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"k", " ", "=", " ", 
   RowBox[{"-", "0.5"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tt2", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Table", "[", " ", 
      RowBox[{
       RowBox[{"k", "^", "n"}], ",", 
       RowBox[{"{", 
        RowBox[{"n", ",", "0", ",", "8"}], "}"}]}], "]"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotMarkers", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Automatic", ",", "Small"}], "}"}]}], ",", " ", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"AxesOrigin", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Black"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"n", ",", "\"\<\!\(\*SubscriptBox[\(u\), \(n\)]\)\>\""}], 
       "}"}]}], ",", " ", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "19"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"k", " ", "=", " ", "0.5"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tt3", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Table", "[", " ", 
      RowBox[{
       RowBox[{"k", "^", "n"}], ",", 
       RowBox[{"{", 
        RowBox[{"n", ",", "0", ",", "8"}], "}"}]}], "]"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotMarkers", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Automatic", ",", "Small"}], "}"}]}], ",", " ", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"AxesOrigin", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Black"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"n", ",", "\"\<\!\(\*SubscriptBox[\(u\), \(n\)]\)\>\""}], 
       "}"}]}], ",", " ", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "19"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"k", " ", "=", " ", "2.0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tt4", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Table", "[", " ", 
      RowBox[{
       RowBox[{"k", "^", "n"}], ",", 
       RowBox[{"{", 
        RowBox[{"n", ",", "0", ",", "8"}], "}"}]}], "]"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotMarkers", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Automatic", ",", "Small"}], "}"}]}], ",", " ", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"AxesOrigin", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Black"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"n", ",", "\"\<\!\(\*SubscriptBox[\(u\), \(n\)]\)\>\""}], 
       "}"}]}], ",", " ", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "19"}]}], "}"}]}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5773478313304515`*^9, 3.577347906147731*^9}, {
  3.5773479762897425`*^9, 3.5773480989467583`*^9}, {3.5773486122251167`*^9, 
  3.5773486207466035`*^9}, {3.5773488301075783`*^9, 3.5773488495166883`*^9}, {
  3.5773488845896945`*^9, 3.577348945491178*^9}, {3.5773492039549613`*^9, 
  3.577349257015996*^9}, {3.5773493218877068`*^9, 3.577349324583861*^9}, {
  3.577350888745326*^9, 3.5773508945056553`*^9}, {3.5773517515656767`*^9, 
  3.5773517679756145`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, 
   GraphicsComplexBox[{{1., 1.}, {2., -2.}, {3., 4.}, {4., -8.}, {5., 16.}, {
    6., -32.}, {7., 64.}, {8., -128.}, {9., 256.}}, {{{}, {}, 
      {GrayLevel[0], LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9}]}}, {
      {GrayLevel[0], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 1], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 2], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 3], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 4], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 5], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 6], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 7], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 8], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 9]}, {}}}], {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{
    FormBox["n", TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*SubscriptBox[\\(u\\), \\(n\\)]\\)\"", TraditionalForm]},
  AxesOrigin->{0, 0},
  BaseStyle->{FontWeight -> "Bold", FontSize -> 19},
  Method->{},
  PlotLabel->FormBox["\"A\"", TraditionalForm],
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.5773517688066626`*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"GraphicsGrid", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tt1", ",", "tt2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"tt3", ",", "tt4"}], "}"}]}], "}"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"%164", ",", 
   RowBox[{"ImageSize", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"938", ",", "560"}], "}"}]}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "Full"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.577348468800913*^9, 3.5773485011757646`*^9}, {
  3.5773509100305433`*^9, 3.5773509116236343`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {{InsetBox[
      GraphicsBox[{{}, 
        GraphicsComplexBox[{{1., 1.}, {2., -2.}, {3., 4.}, {4., -8.}, {5., 
         16.}, {6., -32.}, {7., 64.}, {8., -128.}, {9., 256.}}, {{{}, {}, 
           {GrayLevel[0], LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9}]}}, {
           {GrayLevel[0], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 1], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 2], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 3], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 4], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 5], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 6], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 7], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 8], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 9]}, {}}}], {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["n", TraditionalForm], 
         FormBox[
         "\"\\!\\(\\*SubscriptBox[\\(u\\), \\(n\\)]\\)\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       BaseStyle->{FontWeight -> "Bold", FontSize -> 19},
       Method->{},
       PlotRange->{All, All},
       PlotRangeClipping->True,
       PlotRangePadding->{Automatic, Automatic}], {192., -118.66252583997979`},
       ImageScaled[{0.5, 0.5}], {360., 222.4922359499621}], InsetBox[
      GraphicsBox[{{}, 
        GraphicsComplexBox[{{1., 1.}, {2., -0.5}, {3., 0.25}, {4., -0.125}, {
         5., 0.0625}, {6., -0.03125}, {7., 0.015625}, {8., -0.0078125}, {9., 
         0.00390625}}, {{{}, {}, 
           {GrayLevel[0], LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9}]}}, {
           {GrayLevel[0], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 1], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 2], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 3], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 4], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 5], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 6], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 7], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 8], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 9]}, {}}}], {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["n", TraditionalForm], 
         FormBox[
         "\"\\!\\(\\*SubscriptBox[\\(u\\), \\(n\\)]\\)\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       BaseStyle->{FontWeight -> "Bold", FontSize -> 19},
       Method->{},
       PlotRange->{All, All},
       PlotRangeClipping->True,
       PlotRangePadding->{Automatic, Automatic}], {576., -118.66252583997979`},
       ImageScaled[{0.5, 0.5}], {360., 222.4922359499621}]}, {InsetBox[
      GraphicsBox[{{}, 
        GraphicsComplexBox[{{1., 1.}, {2., 0.5}, {3., 0.25}, {4., 0.125}, {5.,
          0.0625}, {6., 0.03125}, {7., 0.015625}, {8., 0.0078125}, {9., 
         0.00390625}}, {{{}, {}, 
           {GrayLevel[0], LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9}]}}, {
           {GrayLevel[0], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 1], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 2], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 3], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 4], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 5], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 6], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 7], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 8], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 9]}, {}}}], {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["n", TraditionalForm], 
         FormBox[
         "\"\\!\\(\\*SubscriptBox[\\(u\\), \\(n\\)]\\)\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       BaseStyle->{FontWeight -> "Bold", FontSize -> 19},
       Method->{},
       PlotRange->{All, All},
       PlotRangeClipping->True,
       PlotRangePadding->{Automatic, Automatic}], {192., -355.98757751993935`},
       ImageScaled[{0.5, 0.5}], {360., 222.4922359499621}], InsetBox[
      GraphicsBox[{{}, 
        GraphicsComplexBox[{{1., 1.}, {2., 2.}, {3., 4.}, {4., 8.}, {5., 
         16.}, {6., 32.}, {7., 64.}, {8., 128.}, {9., 256.}}, {{{}, {}, 
           {GrayLevel[0], LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9}]}}, {
           {GrayLevel[0], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 1], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 2], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 3], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 4], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 5], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 6], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 7], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 8], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->Small], 9]}, {}}}], {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["n", TraditionalForm], 
         FormBox[
         "\"\\!\\(\\*SubscriptBox[\\(u\\), \\(n\\)]\\)\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       BaseStyle->{FontWeight -> "Bold", FontSize -> 19},
       Method->{},
       PlotRange->{All, All},
       PlotRangeClipping->True,
       PlotRangePadding->{Automatic, Automatic}], {576., -355.98757751993935`},
       ImageScaled[{0.5, 0.5}], {360., 222.4922359499621}]}}, 
   InsetBox["", {195.4194236926361, -58.415820804274574`}, {Left, Baseline},
    Alignment->{Left, Top}], InsetBox[
    StyleBox[Cell[TextData[StyleBox["A",
      FontFamily->"Times New Roman",
      FontSize->20]],
      GeneratedCell->False,
      CellAutoOverwrite->False,
      CellBaseline->Baseline,
      TextAlignment->Left],
     Background->GrayLevel[1.]], {247.82497319579252`, -53.48039391894963}, {
    Left, Baseline},
    Alignment->{Left, Top}], InsetBox[
    StyleBox[Cell[TextData[StyleBox["D",
      FontFamily->"Times New Roman",
      FontSize->20]],
      GeneratedCell->False,
      CellAutoOverwrite->False,
      CellBaseline->Baseline,
      TextAlignment->Left],
     Background->GrayLevel[1.]], {621.4130204924668, -295.316319564305}, {
    Left, Baseline},
    Alignment->{Left, Top}], InsetBox[
    StyleBox[Cell[TextData[StyleBox["C",
      FontFamily->"Times New Roman",
      FontSize->20]],
      GeneratedCell->False,
      CellAutoOverwrite->False,
      CellBaseline->Baseline,
      TextAlignment->Left],
     Background->GrayLevel[1.]], {238.6937031768514, -288.73575015898916`}, {
    Left, Baseline},
    Alignment->{Left, Top}], InsetBox[
    StyleBox[Cell[TextData[StyleBox["B",
      FontFamily->"Times New Roman",
      FontSize->20]],
      GeneratedCell->False,
      CellAutoOverwrite->False,
      CellBaseline->Baseline,
      TextAlignment->Left],
     Background->GrayLevel[1.]], {623.7950909321905, -50.19010921629172}, {
    Left, Baseline},
    Alignment->{Left, Top}]},
  AspectRatio->Full,
  ContentSelectable->True,
  ImagePadding->{{219.137097, 220.137097}, {130.163434, 129.163434}},
  ImageSize->{938, 560},
  PlotRange->{{186., 582.}, {-360.98757751993935`, -113.66252583997979`}},
  PlotRangePadding->Automatic]], "Input",
 CellChangeTimes->{{3.5773509648036757`*^9, 3.577351038671901*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<fig2.0.eps\>\"", ",", "%169", ",", "\"\<EPS\>\""}], 
  "]"}]], "Input",
 NumberMarks->False],

Cell[BoxData["\<\"fig2.0.eps\"\>"], "Output",
 CellChangeTimes->{3.577350762398099*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"SystemOpen", "[", "\"\<fig2.0.eps\>\"", "]"}]], "Input",
 NumberMarks->False],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<fig22.eps\>\"", ",", "%169", ",", "\"\<EPS\>\""}], 
  "]"}]], "Input",
 NumberMarks->False],

Cell[BoxData["\<\"fig22.eps\"\>"], "Output",
 CellChangeTimes->{3.5773499214660006`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"SystemOpen", "[", "\"\<fig22.eps\>\"", "]"}]], "Input",
 NumberMarks->False],

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{"%164", ",", 
   RowBox[{"ImageSize", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"938", ",", "560"}], "}"}]}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "Full"}]}], "]"}]], "Input",
 NumberMarks->False],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RSolve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"y", "[", 
        RowBox[{"n", "+", "1"}], "]"}], "+", 
       RowBox[{"z", "[", "n", "]"}]}], "\[Equal]", "3"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"y", "[", "n", "]"}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"z", "[", 
         RowBox[{"n", "+", "1"}], "]"}]}]}], "\[Equal]", "1"}], ",", 
     RowBox[{
      RowBox[{"y", "[", "0", "]"}], "\[Equal]", "5"}], ",", 
     RowBox[{
      RowBox[{"z", "[", "0", "]"}], "\[Equal]", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", "z"}], "}"}], ",", " ", "n"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"y", "\[Rule]", 
     RowBox[{"Function", "[", 
      RowBox[{
       RowBox[{"{", "n", "}"}], ",", 
       RowBox[{
        SuperscriptBox["2", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], "-", 
          FractionBox["n", "2"]}]], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "3"}], "+", 
          RowBox[{"3", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], "n"]}], "+", 
          RowBox[{"5", " ", 
           SuperscriptBox["2", 
            RowBox[{
             FractionBox["1", "2"], "+", 
             FractionBox["n", "2"]}]]}]}], ")"}]}]}], "]"}]}], ",", 
    RowBox[{"z", "\[Rule]", 
     RowBox[{"Function", "[", 
      RowBox[{
       RowBox[{"{", "n", "}"}], ",", 
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox["2", 
          RowBox[{
           RowBox[{"-", "1"}], "-", 
           FractionBox["n", "2"]}]]}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "3"}], "-", 
          RowBox[{"3", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], "n"]}], "+", 
          SuperscriptBox["2", 
           RowBox[{"2", "+", 
            FractionBox["n", "2"]}]]}], ")"}]}]}], "]"}]}]}], "}"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5368917183125*^9, 3.536892466671875*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"mu", "=", "0"}], ";"}]], "Input",
 CellChangeTimes->{{3.536892856953125*^9, 3.53689286075*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RSolve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"x", "[", 
       RowBox[{"n", "+", "1"}], "]"}], " ", "==", 
      RowBox[{
       RowBox[{"x", "[", "n", "]"}], " ", "-", " ", 
       RowBox[{"0.0005", " ", "*", 
        RowBox[{"x", "[", "n", "]"}], "*", 
        RowBox[{"y", "[", "n", "]"}]}]}]}], " ", ",", " ", 
     RowBox[{
      RowBox[{"y", "[", 
       RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", " ", 
      RowBox[{
       RowBox[{"y", "[", "n", "]"}], "+", " ", 
       RowBox[{"0.0005", "  ", 
        RowBox[{"x", "[", "n", "]"}], "*", 
        RowBox[{"y", "[", "n", "]"}]}], " ", "-", 
       RowBox[{"0.05", "*", 
        RowBox[{"y", "[", "n", "]"}]}]}]}], ",", 
     RowBox[{
      RowBox[{"z", "[", 
       RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"z", "[", "n", "]"}], " ", "+", " ", 
       RowBox[{"0.05", "*", 
        RowBox[{"y", "[", "n", "]"}]}]}]}], " ", ",", " ", 
     RowBox[{
      RowBox[{"x", "[", "0", "]"}], "\[Equal]", "9"}], ",", 
     RowBox[{
      RowBox[{"y", "[", "0", "]"}], "\[Equal]", "5"}], ",", 
     RowBox[{
      RowBox[{"z", "[", "0", "]"}], "\[Equal]", "3"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "z"}], "}"}], ",", " ", "n"}], "]"}]], "Input",
 CellChangeTimes->{{3.536854321078125*^9, 3.536854384015625*^9}, {
   3.53685442425*^9, 3.536854425953125*^9}, {3.536854467359375*^9, 
   3.53685450453125*^9}, {3.536854540484375*^9, 3.536854626359375*^9}, {
   3.53685476959375*^9, 3.53685491903125*^9}, {3.536890693015625*^9, 
   3.5368907209375*^9}, {3.536890805703125*^9, 3.53689086375*^9}, {
   3.536890909953125*^9, 3.53689099421875*^9}, {3.53689106321875*^9, 
   3.5368911091875*^9}, {3.536891157015625*^9, 3.5368911835625*^9}, {
   3.536891234625*^9, 3.53689123771875*^9}, {3.536891292390625*^9, 
   3.5368913635*^9}, {3.53689158740625*^9, 3.53689159965625*^9}, 
   3.536891667125*^9, {3.536891731296875*^9, 3.536891736265625*^9}, {
   3.53689247765625*^9, 3.53689255146875*^9}, {3.5368926838125*^9, 
   3.53689274009375*^9}, {3.53689277625*^9, 3.536892778328125*^9}, {
   3.536893075359375*^9, 3.53689309884375*^9}}],

Cell[BoxData[
 RowBox[{"RSolve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"x", "[", 
       RowBox[{"1", "+", "n"}], "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"x", "[", "n", "]"}], "-", 
       RowBox[{"0.0005`", " ", 
        RowBox[{"x", "[", "n", "]"}], " ", 
        RowBox[{"y", "[", "n", "]"}]}]}]}], ",", 
     RowBox[{
      RowBox[{"y", "[", 
       RowBox[{"1", "+", "n"}], "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"0.95`", " ", 
        RowBox[{"y", "[", "n", "]"}]}], "+", 
       RowBox[{"0.0005`", " ", 
        RowBox[{"x", "[", "n", "]"}], " ", 
        RowBox[{"y", "[", "n", "]"}]}]}]}], ",", 
     RowBox[{
      RowBox[{"z", "[", 
       RowBox[{"1", "+", "n"}], "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"0.05`", " ", 
        RowBox[{"y", "[", "n", "]"}]}], "+", 
       RowBox[{"z", "[", "n", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"x", "[", "0", "]"}], "\[Equal]", "9"}], ",", 
     RowBox[{
      RowBox[{"y", "[", "0", "]"}], "\[Equal]", "5"}], ",", 
     RowBox[{
      RowBox[{"z", "[", "0", "]"}], "\[Equal]", "3"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "z"}], "}"}], ",", "n"}], "]"}]], "Output",
 CellChangeTimes->{
  3.53689124003125*^9, 3.536891328328125*^9, {3.536891648828125*^9, 
   3.536891673125*^9}, 3.53689247*^9, 3.536892574*^9, {3.536892726390625*^9, 
   3.536892741671875*^9}, {3.536892841828125*^9, 3.53689286328125*^9}, 
   3.536893118625*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Transpose", " ", "@", " ", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"x", "[", "n", "]"}], ",", 
         RowBox[{"y", "[", "n", "]"}], ",", 
         RowBox[{"z", "[", "n", "]"}]}], "}"}], "/.", 
       RowBox[{"First", "[", "%", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "0", ",", "70"}], "}"}]}], "]"}]}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotMarkers", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Automatic", ",", "Small"}], "}"}]}], ",", " ", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", "Black", "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.536854236375*^9, 3.536854237421875*^9}, {
  3.53685465853125*^9, 3.5368546591875*^9}, {3.53685473065625*^9, 
  3.53685473196875*^9}, {3.536854934453125*^9, 3.536854934890625*^9}, {
  3.536891174703125*^9, 3.536891175078125*^9}, {3.5368933780625*^9, 
  3.536893380921875*^9}, {3.5368944909375*^9, 3.536894491484375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RSolve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"y", "[", 
       RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"0.5", "  ", 
        RowBox[{"y", "[", "n", "]"}]}], "+", 
       RowBox[{"0.4", " ", 
        RowBox[{"y", "[", "n", "]"}], "*", 
        RowBox[{"z", "[", "n", "]"}]}]}]}], ",", 
     RowBox[{
      RowBox[{"z", "[", 
       RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "0.05"}], "  ", 
        RowBox[{"y", "[", "n", "]"}], "*", 
        RowBox[{"z", "[", "n", "]"}]}], "+", 
       RowBox[{"1.1", " ", 
        RowBox[{"z", "[", "n", "]"}]}]}]}], ",", 
     RowBox[{
      RowBox[{"y", "[", "0", "]"}], "\[Equal]", "500"}], ",", 
     RowBox[{
      RowBox[{"z", "[", "0", "]"}], "\[Equal]", "50"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", "z"}], "}"}], ",", " ", "n"}], "]"}]], "Input",
 CellChangeTimes->{{3.536894511921875*^9, 3.536894512640625*^9}, {
  3.536895493703125*^9, 3.5368955155625*^9}}],

Cell[BoxData[
 RowBox[{"RSolve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"y", "[", 
       RowBox[{"1", "+", "n"}], "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"0.5`", " ", 
        RowBox[{"y", "[", "n", "]"}]}], "+", 
       RowBox[{"0.4`", " ", 
        RowBox[{"y", "[", "n", "]"}], " ", 
        RowBox[{"z", "[", "n", "]"}]}]}]}], ",", 
     RowBox[{
      RowBox[{"z", "[", 
       RowBox[{"1", "+", "n"}], "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"1.1`", " ", 
        RowBox[{"z", "[", "n", "]"}]}], "-", 
       RowBox[{"0.05`", " ", 
        RowBox[{"y", "[", "n", "]"}], " ", 
        RowBox[{"z", "[", "n", "]"}]}]}]}], ",", 
     RowBox[{
      RowBox[{"y", "[", "0", "]"}], "\[Equal]", "500"}], ",", 
     RowBox[{
      RowBox[{"z", "[", "0", "]"}], "\[Equal]", "50"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", "z"}], "}"}], ",", "n"}], "]"}]], "Output",
 CellChangeTimes->{{3.53689449590625*^9, 3.536894514328125*^9}, 
   3.536895523984375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RSolve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"x", "[", 
       RowBox[{"n", "+", "1"}], "]"}], " ", "==", 
      RowBox[{
       RowBox[{"x", "[", "n", "]"}], " ", "-", " ", 
       RowBox[{"0.03", " ", "*", 
        RowBox[{"x", "[", "n", "]"}]}]}]}], " ", ",", " ", 
     RowBox[{
      RowBox[{"y", "[", 
       RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", " ", 
      RowBox[{
       RowBox[{"0.91", "*", 
        RowBox[{"y", "[", "n", "]"}]}], "+", " ", 
       RowBox[{"x", "[", "n", "]"}]}]}], " ", ",", " ", 
     RowBox[{
      RowBox[{"x", "[", "0", "]"}], "\[Equal]", "50"}], ",", 
     RowBox[{
      RowBox[{"y", "[", "0", "]"}], "\[Equal]", "7"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}], ",", " ", "n"}], "]"}]], "Input",
 CellChangeTimes->{{3.55014619140625*^9, 3.550146194421875*^9}, {
  3.5501466143125*^9, 3.550146686796875*^9}, {3.55014673765625*^9, 
  3.550146774328125*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"x", "\[Rule]", 
     RowBox[{"Function", "[", 
      RowBox[{
       RowBox[{"{", "n", "}"}], ",", 
       RowBox[{"50.`", " ", 
        SuperscriptBox["0.97`", "n"]}]}], "]"}]}], ",", 
    RowBox[{"y", "\[Rule]", 
     RowBox[{"Function", "[", 
      RowBox[{
       RowBox[{"{", "n", "}"}], ",", 
       RowBox[{
        SuperscriptBox["2.`", 
         RowBox[{
          RowBox[{"-", "2.`"}], " ", "n"}]], " ", 
        SuperscriptBox["25.`", 
         RowBox[{
          RowBox[{"-", "1.`"}], " ", "n"}]], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"7.`", " ", 
           SuperscriptBox["0.91`", "n"], " ", 
           SuperscriptBox["2.`", 
            RowBox[{"2.`", " ", "n"}]], " ", 
           SuperscriptBox["25.`", 
            RowBox[{"1.`", " ", "n"}]]}], "-", 
          RowBox[{"833.3333333333333`", " ", 
           SuperscriptBox["91.`", "n"]}], "+", 
          RowBox[{"833.3333333333333`", " ", 
           SuperscriptBox["97.`", "n"]}]}], ")"}]}]}], "]"}]}]}], "}"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.550146782734375*^9, 3.550146976859375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Transpose", " ", "@", " ", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"x", "[", "n", "]"}], ",", 
         RowBox[{"y", "[", "n", "]"}]}], "}"}], "/.", 
       RowBox[{"First", "[", "%", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "0", ",", "50"}], "}"}]}], "]"}]}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotMarkers", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Automatic", ",", "Small"}], "}"}]}], ",", " ", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", "Black", "}"}]}], ",", " ", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Time", ",", "\"\<Materials\>\""}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.550146769609375*^9, 3.550146778046875*^9}, {
  3.550146848078125*^9, 3.550146867546875*^9}, {3.550146906984375*^9, 
  3.5501469206875*^9}, {3.550146965578125*^9, 3.5501469724375*^9}}],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJw10wtMU1ccx/HCUPGxjSEGZA1rsSAg71cpj/ZXKG2JLAj4ADeGEOgcTynC
NmFbg4ogOJGBDKIsWlARtynKIxEzhCBUHY8xIZkC6iCSIRtDcGRb67rwPze5
Ofncb3Jz23P+/OTsmFRTDoejMt7/ryvXvGRljQA9WFmhJJtjyen9k91HFWQL
8L/My3l7WE62QmB82q1JPrMNuLVTI9Mfh5O5sNwj3LVqREbmoaq2z9rah9ke
21//wW6pJowswLDd6lOHTJgdkbvv8NXD2aFkJ9zbWj8890RKdsHsB6axNXHM
rkip0lYnjoDsjvQU/aJjDLMn/uiz++Jsk4TshfpSh0R1m5jsDfXvg32Vd0PI
Prjon9dyZzqY7Ish6Y07Y2uY/aAyLXv3lGcQ2R8Sq2FBV2IgWYjaQsvr3tUi
cgDcrvU97BgKIIswv3nmxRZL5kDU7f65TR4vJAfheWN10FKjPzkYC4+zfzNb
9iOHYOlkjzoyilmMtS0ht7XNvmQJDj6NefnrBmbAtva1hGdqnxVrgKKdz5JK
x72pS/FLeeHxC5FkjRSXE29mcLu8qIdi9MXMBZ2QrAnFWEPT2InrntTDYLNx
x+kIH7ImDDllA6OdmR7UZfD3fF6ZUOhOXQZ1/uL64Eo36uFokXg38r53pR6O
5D3rMh/8tI26HNqobRaOehfqclT2vvPjpBuZo4B4M/YPpzhTVyC2k8O7d86J
uhLyHXXn6qe2Ulci7qm5wc6NbJyDvZcSv+EVOFKPgKg1S/zpgAN1Ni9cMgcV
3cYJ8YgkmyPC/RVfvxBHtsCbrZk2R4OSyFao15wv7U5OJdsgfNzKRGPYD/be
Mmn0qjPcDDIP09OPPmnWZZHt8VIYqysrOUAWIJU/WHHm8xyyI0Zv/nmlY7ua
7AT9qLM3b5HZBWeV1gtXCnLJrjgtnh16OM3sjqiOW6EP/A6SPZF1INosL4vZ
C3M1Bl50JbM37GVTu7q0zD7ob9/wZLKB2ReR6RO6r2uY/RA98+q7hs+Y/aHN
6RRUxjEL4Xxi+dt+Z+YAdH81Hle+wL5PhC3vVawxucEciCP64gy3bOYgrDUk
39YLmIPxj6FaLB9lvz8E+44Vx/ceZhZjpEE14ODOLEFPUv4hzij7P4HH/xrW
TRSQjfOSWz1/JIDHuhR1rdcuFfbQfhjn5dHfCX7rVWx/QiHbq3oj0Jz1UHTM
FpVf3plNPQztAhEftbS/xnmJHjwe3DyRSV2G3jKtLtaBbJyXKV3bxapMdj7C
kVD610Jnezr1cBTdt/V4y4xsnJcSc+fd92PSqMuRNGc/wGv4iLoCxVd7FKJl
On/GeUnblF8iimLnUQnbsCS+pOlD6kpsPC/flLyabJyXYm53VqtKRT0Cs8Px
/Yq7qfgPvoanEw==
   "], {{{}, {}, 
     {GrayLevel[0], 
      LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 
       19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36,
        37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51}]}, 
     {GrayLevel[0], 
      LineBox[{52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67,
        68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 
       85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 
       102}]}}, {
     {GrayLevel[0], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 1], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 2], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 3], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 4], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 5], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 6], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 7], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 8], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 9], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 10], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 11], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 12], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 13], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 14], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 15], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 16], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 17], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 18], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 19], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 20], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 21], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 22], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 23], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 24], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 25], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 26], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 27], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 28], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 29], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 30], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 31], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 32], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 33], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 34], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 35], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 36], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 37], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 38], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 39], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 40], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 41], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 42], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 43], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 44], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 45], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 46], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 47], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 48], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 49], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 50], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 51]}, 
     {GrayLevel[0], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 52], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 53], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 54], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 55], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 56], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 57], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 58], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 59], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 60], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 61], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 62], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 63], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 64], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 65], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 66], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 67], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 68], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 69], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 70], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 71], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 72], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 73], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 74], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 75], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 76], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 77], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 78], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 79], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 80], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 81], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 82], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 83], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 84], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 85], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 86], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 87], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 88], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 89], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 90], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 91], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 92], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 93], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 94], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 95], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 96], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 97], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 98], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 99], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 100], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 101], InsetBox[
       StyleBox["\<\"\[FilledSquare]\"\>",
        StripOnInput->False,
        FontSize->Small], 102]}, {}}}],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{
    FormBox["Time", TraditionalForm], 
    FormBox["\"Materials\"", TraditionalForm]},
  AxesOrigin->{0, 0},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.5501467864375*^9, 3.550146934328125*^9, 
  3.550146978796875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"x", " ", "=", " ", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"c", "[", 
        RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", 
       RowBox[{
        RowBox[{"0.8", " ", 
         RowBox[{"c", "[", "n", "]"}]}], " ", "+", " ", "x"}]}], " ", ",", 
      RowBox[{
       RowBox[{"c", "[", "0", "]"}], "\[Equal]", "640"}]}], "}"}], ",", " ", 
    "c", ",", "n"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"a1", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"c", "[", "n", "]"}], "/.", 
       RowBox[{"First", "[", "%", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "0", ",", "20"}], "}"}]}], "]"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"PlotMarkers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Automatic", ",", "Small"}], "}"}]}], ",", " ", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"AxesOrigin", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Black", ",", "Black", ",", "Black"}], "}"}]}], ",", 
    RowBox[{"AxesLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Time", " ", "in", " ", "Hours"}], " ", ",", 
       "\"\<Drug Concentration\>\""}], "}"}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.55015038328125*^9, 3.550150425359375*^9}, {
  3.550150751265625*^9, 3.550150752625*^9}, {3.55015078378125*^9, 
  3.5501507839375*^9}, {3.550150838375*^9, 3.5501508416875*^9}, {
  3.55015667578125*^9, 3.550156744625*^9}, {3.550156799671875*^9, 
  3.55015681775*^9}, {3.550156871609375*^9, 3.55015688965625*^9}, {
  3.55015749075*^9, 3.550157515453125*^9}}],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQDQEf7CF0iwNUAEIHNED5HA6zZgLBziooX8DhUZXI
OnfGMihfxGHribJ9862KoHwJh/e8+wxmZuVB+TIOB5YYRrlPzYTyFRz+b1P3
yNmeCuUrOZz9EXS5c34SlK/isCTB6Q67WgKUr+Zw5Szzr6KwGChfw6GsMFOv
XzsSytdyiP3y9uONRWFQvo7DE83ugw9mh0D5eg5B7zjObf4TBOUbOPCpst/o
3xAI5Rs6XA+YX3lzWQCUb+Rw4Pk/jf4l/lC+sQNDsFF7UYAflG/iMKs0en60
gy+Ub+rgMXH9pvVpPg4AVnRU7A==
   "], {{{}, {}, 
     {GrayLevel[0], 
      LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 
       19, 20, 21}]}}, {
     {GrayLevel[0], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 1], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 2], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 3], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 4], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 5], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 6], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 7], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 8], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 9], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 10], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 11], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 12], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 13], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 14], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 15], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 16], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 17], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 18], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 19], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 20], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 21]}, {}}}],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{
    FormBox[
     RowBox[{"Hours", " ", "in", " ", "Time"}], TraditionalForm], 
    FormBox["\"Drug Concentration\"", TraditionalForm]},
  AxesOrigin->{0, 0},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.550150461953125*^9, 3.550150593046875*^9, 3.550150638765625*^9, 
   3.55015075484375*^9, 3.55015078534375*^9, 3.550150844703125*^9, {
   3.550156717578125*^9, 3.550156745515625*^9}, {3.5501568023125*^9, 
   3.55015681878125*^9}, 3.55015694178125*^9, {3.55015749415625*^9, 
   3.55015751715625*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"x", " ", "=", " ", "40"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"c", "[", 
        RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", 
       RowBox[{
        RowBox[{"0.8", " ", 
         RowBox[{"c", "[", "n", "]"}]}], " ", "+", " ", "x"}]}], " ", ",", 
      RowBox[{
       RowBox[{"c", "[", "0", "]"}], "\[Equal]", "640"}]}], "}"}], ",", " ", 
    "c", ",", "n"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"a2", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"c", "[", "n", "]"}], "/.", 
       RowBox[{"First", "[", "%", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "0", ",", "20"}], "}"}]}], "]"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"PlotMarkers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Automatic", ",", "Small"}], "}"}]}], ",", " ", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"AxesOrigin", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Black", ",", "Black", ",", "Black"}], "}"}]}], ",", 
    RowBox[{"AxesLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Time", " ", "in", " ", "Hours"}], " ", ",", 
       "\"\<Drug Concentration\>\""}], "}"}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.550156898578125*^9, 3.550156918171875*^9}, {
  3.55015752534375*^9, 3.550157538953125*^9}}],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQDQEf7CF0iwNUAEI7NEL5HA6zZgKBZB2UL+Agts79
YdWUKihfxOGeClvj1MPlUL6Eg8T2iwz3mkqhfBkHYR2+9LqtxVC+gsPKTjv5
VJciKF/JQTFvxiZZ2UIoX8VBKuJB3xODAihfzeFw5FnxK8/zoHwNhzkihZVl
O3OhfC0Hj7sHfk08ngPl6zhYPzFO4mOD8fUcDAK+bbHLzobyDRwO3JwYm/o+
C8o3dEh5uFw8sAfGN3J449u2htcWxjd2UOZm7VryNxPKN3F4ycHC8eoUjG/q
0J5rdjlkUaYDAGjhT18=
   "], {{{}, {}, 
     {GrayLevel[0], 
      LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 
       19, 20, 21}]}}, {
     {GrayLevel[0], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 1], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 2], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 3], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 4], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 5], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 6], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 7], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 8], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 9], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 10], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 11], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 12], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 13], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 14], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 15], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 16], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 17], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 18], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 19], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 20], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 21]}, {}}}],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{
    FormBox[
     RowBox[{"Hours", " ", "in", " ", "Time"}], TraditionalForm], 
    FormBox["\"Drug Concentration\"", TraditionalForm]},
  AxesOrigin->{0, 0},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.550156946171875*^9, {3.5501575275*^9, 3.550157540328125*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"x", " ", "=", " ", "120"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"c", "[", 
        RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", 
       RowBox[{
        RowBox[{"0.8", " ", 
         RowBox[{"c", "[", "n", "]"}]}], " ", "+", " ", "x"}]}], " ", ",", 
      RowBox[{
       RowBox[{"c", "[", "0", "]"}], "\[Equal]", "640"}]}], "}"}], ",", " ", 
    "c", ",", "n"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"a3", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"c", "[", "n", "]"}], "/.", 
       RowBox[{"First", "[", "%", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "0", ",", "20"}], "}"}]}], "]"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"PlotMarkers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Automatic", ",", "Small"}], "}"}]}], ",", " ", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"AxesOrigin", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Black", ",", "Black", ",", "Black"}], "}"}]}], ",", 
    RowBox[{"AxesLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Time", " ", "in", " ", "Hours"}], " ", ",", 
       "\"\<Drug Concentration\>\""}], "}"}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.550156924484375*^9, 3.55015695371875*^9}}],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQDQEf7CF0iwNUAEIfaIbyORzOngGCHhhfwGFJgS3X
9WQYX8QhoHd6npAzjC/hwFu4pvu2Bowv47CkV/naI2EYX8Fh2/Wme9LMML6S
Q3yl6dP1X5ugfBUHycQjsp9fwfhqDmt9L4jHPILxNRz2Xr95v+Y2jK/lkFL5
sP7vVRhfx+GVbuPM6RdhfD2HPSomD4XOwfgGDlMDDvs6nYbxDR1WFZ+/zngS
xjdyUPq2dI3JcRjf2GHrxMC9h4/C+CYOk0pKps85AuObOtz+plm54XCTAwDm
3FvW
   "], {{{}, {}, 
     {GrayLevel[0], 
      LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 
       19, 20, 21}]}}, {
     {GrayLevel[0], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 1], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 2], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 3], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 4], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 5], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 6], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 7], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 8], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 9], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 10], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 11], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 12], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 13], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 14], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 15], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 16], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 17], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 18], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 19], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 20], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 21]}, {}}}],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{
    FormBox[
     RowBox[{"Hours", " ", "in", " ", "Time"}], TraditionalForm], 
    FormBox["\"Drug Concentration\"", TraditionalForm]},
  AxesOrigin->{0, 0},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.550156955015625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"x", " ", "=", " ", "200"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"c", "[", 
        RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", 
       RowBox[{
        RowBox[{"0.8", " ", 
         RowBox[{"c", "[", "n", "]"}]}], " ", "+", " ", "x"}]}], " ", ",", 
      RowBox[{
       RowBox[{"c", "[", "0", "]"}], "\[Equal]", "640"}]}], "}"}], ",", " ", 
    "c", ",", "n"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"a4", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"c", "[", "n", "]"}], "/.", 
       RowBox[{"First", "[", "%", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "0", ",", "20"}], "}"}]}], "]"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"PlotMarkers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Automatic", ",", "Small"}], "}"}]}], ",", " ", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"AxesOrigin", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Black", ",", "Black", ",", "Black"}], "}"}]}], ",", 
    RowBox[{"AxesLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Time", " ", "in", " ", "Hours"}], " ", ",", 
       "\"\<Drug Concentration\>\""}], "}"}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.550156936*^9, 3.550156963375*^9}}],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQDQEf7CF0iwNUAEI7tEH5HA7nzgABTweUL+Bgy3V9
cUFtJ5Qv4mDEsUYmakkXlC/h0Mf2QcxjQjeUL+Ngx3qggs23B8pXcJiRlabL
+gTGV3JYt1vu44WYXihfxUF5msSX4r0wvprDS5e1moe5+qB8DYewrHDFOR4w
vpZD6W6hRrEqGF/H4UhS6azVC2F8PYfsrVqiYQdhfAOHPVpKLqtvwfiGDr/f
bcl8/w7GN3I4E6H1TvU/jG/ssOiBYoQcTz+Ub+Lw4tnzNXViML6pQ2hQ297T
cv0OAE46Uv4=
   "], {{{}, {}, 
     {GrayLevel[0], 
      LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 
       19, 20, 21}]}}, {
     {GrayLevel[0], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 1], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 2], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 3], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 4], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 5], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 6], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 7], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 8], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 9], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 10], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 11], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 12], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 13], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 14], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 15], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 16], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 17], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 18], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 19], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 20], InsetBox[
       StyleBox["\<\"\[FilledCircle]\"\>",
        StripOnInput->False,
        FontSize->Small], 21]}, {}}}],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{
    FormBox[
     RowBox[{"Hours", " ", "in", " ", "Time"}], TraditionalForm], 
    FormBox["\"Drug Concentration\"", TraditionalForm]},
  AxesOrigin->{0, 0},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.550156964421875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{"a1", ",", "a2", ",", "a3", ",", "a4"}], "]"}]], "Input",
 CellChangeTimes->{{3.550156966625*^9, 3.550156974703125*^9}}],

Cell[BoxData[
 GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQDQEf7CF0iwNUAEIHNED5HA6zZgLBziooX8DhUZXI
OnfGMihfxGHribJ9862KoHwJh/e8+wxmZuVB+TIOB5YYRrlPzYTyFRz+b1P3
yNmeCuUrOZz9EXS5c34SlK/isCTB6Q67WgKUr+Zw5Szzr6KwGChfw6GsMFOv
XzsSytdyiP3y9uONRWFQvo7DE83ugw9mh0D5eg5B7zjObf4TBOUbOPCpst/o
3xAI5Rs6XA+YX3lzWQCUb+Rw4Pk/jf4l/lC+sQNDsFF7UYAflG/iMKs0en60
gy+Ub+rgMXH9pvVpPg4AVnRU7A==
    "], {{{}, {}, 
      {GrayLevel[0], 
       LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18,
         19, 20, 21}]}}, {
      {GrayLevel[0], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 1], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 2], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 3], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 4], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 5], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 6], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 7], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 8], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 9], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 10], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 11], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 12], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 13], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 14], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 15], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 16], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 17], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 18], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 19], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 20], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 21]}, {}}}], GraphicsComplexBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQDQEf7CF0iwNUAEI7NEL5HA6zZgKBZB2UL+Agts79
YdWUKihfxOGeClvj1MPlUL6Eg8T2iwz3mkqhfBkHYR2+9LqtxVC+gsPKTjv5
VJciKF/JQTFvxiZZ2UIoX8VBKuJB3xODAihfzeFw5FnxK8/zoHwNhzkihZVl
O3OhfC0Hj7sHfk08ngPl6zhYPzFO4mOD8fUcDAK+bbHLzobyDRwO3JwYm/o+
C8o3dEh5uFw8sAfGN3J449u2htcWxjd2UOZm7VryNxPKN3F4ycHC8eoUjG/q
0J5rdjlkUaYDAGjhT18=
    "], {{{}, {}, 
      {GrayLevel[0], 
       LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18,
         19, 20, 21}]}}, {
      {GrayLevel[0], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 1], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 2], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 3], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 4], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 5], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 6], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 7], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 8], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 9], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 10], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 11], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 12], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 13], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 14], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 15], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 16], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 17], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 18], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 19], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 20], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 21]}, {}}}], GraphicsComplexBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQDQEf7CF0iwNUAEIfaIbyORzOngGCHhhfwGFJgS3X
9WQYX8QhoHd6npAzjC/hwFu4pvu2Bowv47CkV/naI2EYX8Fh2/Wme9LMML6S
Q3yl6dP1X5ugfBUHycQjsp9fwfhqDmt9L4jHPILxNRz2Xr95v+Y2jK/lkFL5
sP7vVRhfx+GVbuPM6RdhfD2HPSomD4XOwfgGDlMDDvs6nYbxDR1WFZ+/zngS
xjdyUPq2dI3JcRjf2GHrxMC9h4/C+CYOk0pKps85AuObOtz+plm54XCTAwDm
3FvW
    "], {{{}, {}, 
      {GrayLevel[0], 
       LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18,
         19, 20, 21}]}}, {
      {GrayLevel[0], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 1], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 2], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 3], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 4], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 5], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 6], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 7], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 8], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 9], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 10], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 11], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 12], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 13], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 14], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 15], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 16], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 17], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 18], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 19], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 20], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 21]}, {}}}], GraphicsComplexBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQDQEf7CF0iwNUAEI7tEH5HA7nzgABTweUL+Bgy3V9
cUFtJ5Qv4mDEsUYmakkXlC/h0Mf2QcxjQjeUL+Ngx3qggs23B8pXcJiRlabL
+gTGV3JYt1vu44WYXihfxUF5msSX4r0wvprDS5e1moe5+qB8DYewrHDFOR4w
vpZD6W6hRrEqGF/H4UhS6azVC2F8PYfsrVqiYQdhfAOHPVpKLqtvwfiGDr/f
bcl8/w7GN3I4E6H1TvU/jG/ssOiBYoQcTz+Ub+Lw4tnzNXViML6pQ2hQ297T
cv0OAE46Uv4=
    "], {{{}, {}, 
      {GrayLevel[0], 
       LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18,
         19, 20, 21}]}}, {
      {GrayLevel[0], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 1], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 2], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 3], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 4], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 5], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 6], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 7], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 8], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 9], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 10], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 11], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 12], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 13], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 14], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 15], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 16], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 17], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 18], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 19], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 20], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->Small], 21]}, {}}}]},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{
    FormBox[
     RowBox[{"Hours", " ", "in", " ", "Time"}], TraditionalForm], 
    FormBox["\"Drug Concentration\"", TraditionalForm]},
  AxesOrigin->{0, 0},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.550156976765625*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.550150536265625*^9, 3.55015058234375*^9}, {
  3.550150613640625*^9, 3.550150621765625*^9}, {3.55015074096875*^9, 
  3.55015074925*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.550150765828125*^9, 3.550150765875*^9}}],

Cell[BoxData[{
 RowBox[{"RSolve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"n", "+", "1"}], "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"1.04", " ", 
        RowBox[{"a", "[", "n", "]"}]}], " ", "-", " ", "2000"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", "0", "]"}], "\[Equal]", "40000"}]}], "}"}], ",", " ", 
   "a", ",", "n"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"cc", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"a", "[", "n", "]"}], "/.", 
      RowBox[{"First", "[", "%", "]"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "0", ",", "41"}], "}"}]}], "]"}]}]}], "Input"],

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"cc", ",", "dd", ",", "ee"}], "}"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotMarkers", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Automatic", ",", "Small"}], "}"}]}], ",", " ", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Black", ",", "Black", ",", "Black"}], "}"}]}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Time", " ", ",", "\"\<Amount in Rupees\>\""}], "}"}]}]}], 
  "]"}]], "Input"]
},
WindowSize->{1877, 944},
WindowMargins->{{Automatic, 0}, {Automatic, -28}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (November 20, 2012)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 2097, 55, 92, "Input"],
Cell[2667, 79, 476, 13, 33, "Output"],
Cell[3146, 94, 5036, 80, 152, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8219, 179, 2111, 56, 92, "Input"],
Cell[10333, 237, 1052, 29, 33, "Output"],
Cell[11388, 268, 3005, 45, 92, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14430, 318, 1156, 31, 72, "Input"],
Cell[15589, 351, 749, 20, 33, "Output"],
Cell[16341, 373, 1284, 22, 52, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17662, 400, 783, 23, 52, "Input"],
Cell[18448, 425, 745, 20, 33, "Output"],
Cell[19196, 447, 1291, 20, 52, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20524, 472, 784, 23, 52, "Input"],
Cell[21311, 497, 752, 20, 33, "Output"],
Cell[22066, 519, 1277, 22, 52, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23380, 546, 1087, 25, 31, "Input"],
Cell[24470, 573, 16880, 429, 227, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41387, 1007, 1426, 35, 72, "Input"],
Cell[42816, 1044, 1019, 24, 33, "Output"],
Cell[43838, 1070, 998, 17, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[44873, 1092, 864, 25, 52, "Input"],
Cell[45740, 1119, 702, 20, 33, "Output"],
Cell[46445, 1141, 699, 13, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[47181, 1159, 1386, 29, 31, "Input"],
Cell[48570, 1190, 4638, 121, 218, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[53245, 1316, 2706, 65, 112, "Input"],
Cell[55954, 1383, 794, 22, 33, "Output"],
Cell[56751, 1407, 873, 15, 31, "Output"],
Cell[57627, 1424, 3597, 90, 193, "Output"]
}, Open  ]],
Cell[61239, 1517, 1150, 27, 72, "Input"],
Cell[CellGroupData[{
Cell[62414, 1548, 3043, 74, 72, "Input"],
Cell[65460, 1624, 2520, 60, 33, "Output"],
Cell[67983, 1686, 9300, 230, 237, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[77320, 1921, 4976, 129, 192, "Input"],
Cell[82299, 2052, 1806, 46, 254, "Output"]
}, Open  ]],
Cell[84120, 2101, 602, 17, 52, "Input"],
Cell[84725, 2120, 10002, 232, 575, "Input"],
Cell[CellGroupData[{
Cell[94752, 2356, 146, 4, 31, "Input"],
Cell[94901, 2362, 87, 1, 31, "Output"]
}, Open  ]],
Cell[95003, 2366, 101, 2, 31, "Input"],
Cell[CellGroupData[{
Cell[95129, 2372, 145, 4, 31, "Input"],
Cell[95277, 2378, 88, 1, 31, "Output"]
}, Open  ]],
Cell[95380, 2382, 100, 2, 31, "Input"],
Cell[95483, 2386, 250, 7, 31, "Input"],
Cell[CellGroupData[{
Cell[95758, 2397, 685, 21, 31, "Input"],
Cell[96446, 2420, 1452, 47, 48, "Output"]
}, Open  ]],
Cell[97913, 2470, 130, 3, 31, "Input"],
Cell[CellGroupData[{
Cell[98068, 2477, 2196, 50, 31, "Input"],
Cell[100267, 2529, 1480, 41, 31, "Output"]
}, Open  ]],
Cell[101762, 2573, 1214, 29, 31, "Input"],
Cell[CellGroupData[{
Cell[103001, 2606, 1072, 31, 31, "Input"],
Cell[104076, 2639, 1024, 30, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[105137, 2674, 986, 27, 31, "Input"],
Cell[106126, 2703, 1164, 34, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[107327, 2742, 1156, 29, 31, "Input"],
Cell[108486, 2773, 13990, 354, 239, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[122513, 3132, 1863, 48, 72, "Input"],
Cell[124379, 3182, 3613, 91, 204, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[128029, 3278, 1599, 44, 72, "Input"],
Cell[129631, 3324, 3368, 87, 204, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[133036, 3416, 1551, 43, 72, "Input"],
Cell[134590, 3461, 3308, 86, 204, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[137935, 3552, 1543, 43, 72, "Input"],
Cell[139481, 3597, 3316, 86, 204, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[142834, 3688, 167, 3, 31, "Input"],
Cell[143004, 3693, 12279, 308, 204, "Output"]
}, Open  ]],
Cell[155298, 4004, 184, 3, 31, "Input"],
Cell[155485, 4009, 89, 1, 31, "Input"],
Cell[155577, 4012, 720, 22, 52, "Input"],
Cell[156300, 4036, 706, 19, 31, "Input"]
}
]
*)

(* End of internal cache information *)
