(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     45851,        991]
NotebookOptionsPosition[     44494,        941]
NotebookOutlinePosition[     44918,        957]
CellTagsIndexPosition[     44875,        954]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"setstate", "[", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}], "]"}], ";", 
  RowBox[{"setparm", "[", 
   RowBox[{"{", "\[Mu]", "}"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"slopevec", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "y"}], "+", 
      RowBox[{"x", "*", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["x", "2"], "+", 
         SuperscriptBox["y", "2"], " ", "+", " ", "\[Mu]"}], ")"}], "*", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         SuperscriptBox["x", "2"], "-", 
         SuperscriptBox["y", "2"]}], ")"}]}]}], ",", 
     RowBox[{"x", "+", 
      RowBox[{"y", "*", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["x", "2"], "+", 
         SuperscriptBox["y", "2"], " ", "+", " ", "\[Mu]"}], ")"}], "*", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         SuperscriptBox["x", "2"], "-", 
         SuperscriptBox["y", "2"]}], ")"}]}]}]}], "}"}]}], ";", 
  RowBox[{"sysname", "=", "\"\<SubCritical Hopf\>\""}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData["findpolyeq"], "Input"],

Cell[BoxData["findpolyeq"], "Output",
 CellChangeTimes->{3.54555538678125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"polarslope", "=", 
  RowBox[{"polartrans", "[", 
   RowBox[{"x", ",", "y", ",", "r", ",", "\[Theta]"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"polartrans", "[", 
  RowBox[{"x", ",", "y", ",", "r", ",", "\[Theta]"}], "]"}]], "Output",
 CellChangeTimes->{3.545555388375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eigsys", "[", 
  RowBox[{"{", 
   RowBox[{"0", ",", "0"}], "}"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"eigsys", "[", 
  RowBox[{"{", 
   RowBox[{"0", ",", "0"}], "}"}], "]"}]], "Output",
 CellChangeTimes->{3.545555389546875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"plot1", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", 
      SqrtBox[
       RowBox[{"-", "\[Mu]"}]], ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Mu]", ",", 
      RowBox[{"-", "2"}], ",", 
      RowBox[{"-", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1.5"}], ",", "1.5"}], "}"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLabel", "\[Rule]", "\"\<Subcritical Hopf\>\""}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<\[Mu]\>\"", ",", "\"\<x\>\""}], "}"}]}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "500"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"DisplayFunction", " ", "\[Rule]", " ", "Identity"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Dashing", "[", 
        RowBox[{"{", 
         RowBox[{"0.03", ",", "0.0"}], "}"}], "]"}], ",", 
       RowBox[{"Dashing", "[", 
        RowBox[{"{", 
         RowBox[{"0.03", ",", "0.0"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Dashing", "[", 
        RowBox[{"{", 
         RowBox[{"0.03", ",", "0.03"}], "}"}], "]"}]}], "}"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.54555507875*^9, 3.54555508334375*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], Dashing[{0.03, 0.}], LineBox[CompressedData["
1:eJxN0XlI0wEUB/ClM11mmatpGuEidZV4H0uSJYKaoOhwpjkip3ZK08qseWaJ
HWsplSW1ctHSCrVbzeaKdKGJR2SiloiZ6Gymrh1eWwXx++7B4/GBL99/Hp3H
Z6eZkUikqL/773ZcKZ43Go1y0v/hGqx4zQb4Z7qwLXcJtom8enNuHo4mSwLU
Grj71JtjY5Nwb7Ja2dEHD/kmD1bUwf6aIkFGAmw57dRqYwmrHDPfhdYbCDuk
rMx9tQ9uHt048ms1/PBs9vL9DUuEq9jCryd4sHOSw95IO3ioUCnmNi0Sth/2
veB/GE7lb3etcoS1TsVnOC0LhM3NIs63H4c5FrFRuRvg10xai0IxT/iWlD3W
dxJ+69mrcHGGk9Wd7KCuOcJhn1eJL2XDrB8rKrLo8HPP/J2uPXrC6TcCH1AF
cCXzYP0HBjxO4QjW9usIZ+lLFsRFcJ6zD2PKG25L20TNGdAS3jLYWVd5DiZf
nNUJ/eDN8VzDy28awvKk4CdSIXy0bIDqEQzzRmX+6rHfhHsyHMwLyuFix0ZR
OAt+sdTd+kWlxj9spbUGMZwXIuekhMMFj2OqRdpZwgofRqP2DkxXNuXoImDd
gGKiWT9D2G7CnvZeAld7Dasux8Cx1anZMySYFewpL3s0jbx15jN9IhzkLesq
TYA74ikqxm54RiJxS4wzyTM/3W6Mhj+m+pYIQuEpmSZp0R0u/B5y+to22I4i
KnffCgfGufZw3UzyyvgwGR1eY9/glU+D7+8gR9PWwQG8mCO1VHhPzbh0yBa+
F7reiWUN+x1KY/ZRYIXoKYdvBU/27yq9awHnG6/XBJJhW5eR9i4zk/5Ij/ED
y0z6MwQWJBL8B7FSaL4=
     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], Dashing[{0.03, 0.}], 
    LineBox[CompressedData["
1:eJwVlHs0lHkcxmeLGJa10VRDSbtum6KilOx3yznCOXXKccmSXaK7aJdlh6Qi
XcRIW6lGrt32MK1Icvl2HblkELlVp9PKlmJ/7/vO+45hmH33j+95zuc5z3nO
89fXJjLWP3qGQCDYxN//2paTMaHT6TAvOieqoJCDsGnDyMZpHcrLR+VOPH/e
n9WcMqXDgRQzzf2rHJj45V3UTOiw0rEkvbeAg816RasYVodCU02amYyDjqT6
X4Y/6TA82df0aD4HPRHMSFuvDuOMpJIdZzl4szJiMF+uwy6TDWet0zlwY49K
4rbpMG2Xn8vsaA4MiOVTEwMd+rZtz/y8kYNR8cGHXjXTeDHPWui6hIN5O75M
ufvzNAYrOkzfGXPQOLTw3b9fTWNAzAtl6hgLN48lztp5bwoXWD/QJrWzcN0/
61V85BQ+STh2c6CChUWh88L9Zk/hLklJzopcFt6kjcjC6rTYRkHpYBwLc9+u
POm2V4s+Ho/OpPqzEBW7xu66WIsGD6uXSl1Z4CwzjgQ+mcTsl6aRw+YszJzh
c6Ll10k0Lbnl9j2rgkD9rZtSrCbR/d5ucccLFdx3Fz1RKCawXms93lypgstl
/sO9v03g4kw/5fM8FTxw7lHYLprAPi43ceqgCiKYdv+1Sg2GHKAtPPxV4N1t
KjudqMGmTiPlRWcVwHuj/AQbDTIh7U+3m6jgjnPqD3ad4/iq3vv2mlEG9l9Y
fc1cMo7SI0MPbVsYKHTfXdPkMI6HiwtnLb3JwAdhoMSiX41WTPys0hMMJIxn
TsqOqlEQLDkrjmbg0KIVDmPL1fjP2pd11V4MNEcvNk8e4PAS3Xd8gzUDjoPt
8sJ0Dgu0CefcJmnQO0Wrs1w5DO2yjA7up+HboLDp6tcszn9vURFcRQOGet4u
y2LR45FF3OlcGg7kDpgv82TxvGrn22WxNEQONbgxwyocc1ggv+JLQ2fcvJmH
z6vQqjy80MeOhgxxbfZGUOHl5A79Ch0FVVMdT1+OMljdbScNGqSAMyurmJYx
GKBwtIqpoeDQegzcsZHB+3pVrK2UgsN/brmRzdF4UhRwbOk+ChQrHGq5Aho9
L5CuxxsosBmpS1b70NgX0dJeK6ZAPaD42DhOYeEpZz1jlsDsj3NFj4so/OR3
LUHZSuCGy9vRM1so3O9oVqoqJbD1RlQiJaDw0rOxjPRUAuDpjLm3CIYn1bjs
DeDzxgcrx0MIlgwPtTQ4EVi7vEEp3UawuzGhyZjntiDhqEMwwcxn4fUhSwhQ
RUX2IQEEj6e45bCOfN6960rtZoIx8v4+J3sCrVErMyVeBFs7F07m2xAYa2BD
tU4Et3nJ4g+ICKT9vf73c0sIvhJ5S+rm8PuF2eedviO4x9w+yZDn1QF2nWH2
BDWJZ8KKzfn8SJB3gw1BOl7Z1GNG4Ou591xSRQRnVnnZexgTKF2nt1k0h+DH
NpU804jAqsgt+yrMCcbffe7SLSTwY/mHsjdmBHNf0+IYQwLFXvMtwZhgj2xU
WqBPwHVPtHuvkN//04OBET0Ciuy/AmMNCarllVaref7U7yu9qk+wpo86oZxB
IFX3RznvY7Ns3R1Lns1s37XwPh5pLe7Z9QXf77fsA69YH/wNuSPg++Mk+gIB
QbF7A//OCPwHo7OrvQ==
     "]]}, 
   {Hue[0.14213595499957954`, 0.6, 0.6], Dashing[{0.03, 0.03}], 
    LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQfaa/9df////3M4DBB/uriZ9fnbmO4N8zTrw9cz2C
b/q1qaogAsFn/yB9lJcdwX8rVXjQefs/OF8imadmWwKCv++J3KP3/Aj+yuZy
trQdf+H85UE9d0qSEHyFaIk4LyEE/17Dq7kxu//A+eIPjDtNsxD8lHxLteVS
CP436dbG0CO/4XxmJo+OU8UIfihroG+NDIK/y0LsyLFjv+D82UuDnl0vQ/AP
6F89pqqA4Cd+Phdkdf4nnO92hW9udzmCb/+Ua2apIoK/Wb/OQe3iDzg/Z7r5
MuEqBH+BRcb24xoI/gvO0CqRm9/h/NIf7b/nNiH4tQpGGu8MEfyTqUrC1be+
wfmat8+tX9CC4LN0ffreY4Lgq4TF/Nt69yucvz/adsPSHgQ/b+ItYT1bBD/p
yV7Tz8++wPkXCySY66ch+K1SO/vc7RH8LX8vHL329jMiPgSWrvs3F8Gvddwf
muyO4NevDljR9+0TnH/MSGPnt3kIvuKr3dXfPRD877eOvdz34yOcL/RSXOzw
QgR/hcGDt70BCH7gipTyjwwIvr2t/v6Jqz4g1HMXbvoRieC/2/s1+o8Ogm9S
UMUKpOF8AGPHN7w=
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction:>Identity,
  Frame->True,
  FrameLabel->{
    FormBox["\"\[Mu]\"", TraditionalForm], 
    FormBox["\"x\"", TraditionalForm]},
  ImageSize->500,
  PlotLabel->FormBox["\"Subcritical Hopf\"", TraditionalForm],
  PlotRange->{{-2, 2}, {-1.5, 1.5}},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.54555539065625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"plot2", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", 
      SqrtBox[
       RowBox[{"-", "\[Mu]"}]], ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Mu]", ",", 
      RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1.5"}], ",", "1.5"}], "}"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLabel", "\[Rule]", "\"\<Subcritical Hopf\>\""}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<\[Mu]\>\"", ",", "\"\<x\>\""}], "}"}]}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
    RowBox[{"DisplayFunction", "\[Rule]", "Identity"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Dashing", "[", 
        RowBox[{"{", 
         RowBox[{"0.03", ",", "0.00"}], "}"}], "]"}], ",", 
       RowBox[{"Dashing", "[", 
        RowBox[{"{", 
         RowBox[{"0.03", ",", "0.03"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Dashing", "[", 
        RowBox[{"{", 
         RowBox[{"0.03", ",", "0.0"}], "}"}], "]"}]}], "}"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.54555509271875*^9, 3.54555509946875*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], Dashing[{0.03, 0.}], LineBox[CompressedData["
1:eJxF1HtI01EUB/CVq2xKPiA106SwHGWiW2o4A12o1JYvMisCX9l0vma1VZA/
fLRmhq98YVmYNTDNTSjHLGk+hub4QWY+M3+bpnPztSyXOjQrqHMvHC6ff+6B
c7/37o/PiEzcSiKRzvypv3uVi4Vxc9OgIP1b8nUb5e0N5JFRh7I1E7Jj+SGv
H0bkGnNmmnYOuXbp5jQ+jNzQpR2sliK3cTpl9Bhk7uw2o6Z5EWyl8S3Yuwt5
zHsyV5S+APbqdlhN7ZgHZ/WeUKpdkCN3GCxx3hw4TOzQqlfOgpkyz7ZyV2TF
lkFGq0APprVzbFMGdGCcuMoO9Ub+5ksxa8yfAVPIJdYVM1qwhFL3cPU48q1M
9/zCwmmwH0uMSxemwMKYhkJWAHK39rH4+pOv4NJ6Zz97wyQ4T7WbNsdETolZ
z2bXTYDHPTLYbssacFBmX3pxBPILt7P6iMtqNN8Jl8UbFAJsynlfK+/5Anav
useeTx4Dv0xlKHJtP4P3UFVqev8IuPp85tqwYBi8PcPYXkkbAncEccPkywPg
ktKVIfzRJzCrK85y/UI/Op875bdvow9cvyDykKV/QHkSUflGAw7+aWFqcmSo
wDsvCZn81z3gk5WBvS0rSpTnCPX425BOcLk0rWbxvgIcWIrFeTm9QfmmmBGE
eQu6T+Fpgb1VMzigfmbaN1IM1swya9yxSnByGNtAd0X+/iqKyVBVgMlZSbpT
dshUq6JjHEkZmEcfxZ8SJeDNFcJ0FLsLtu5YqvVXCcEHCsghLDvkYKfDZUmS
PHBRAP/IMyIb7G9rL/fEBODY5/7kUDs++I5PfHiK5Bp6HxebdGKCB5YFi2g+
2BXwL26/iidJQP2LnRMaiVj0P0g5boHYOTTP1Y1oGREOfpBDtYnGgsEJBxum
cjEf8OlE3cd2fdS7//4NyFZggg==
     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], Dashing[{0.03, 0.03}], 
    LineBox[CompressedData["
1:eJwVkHk4FAgfgNlBJdHtCmUlrHxuG/JDH/mwFZuS2ijKoHHkqv2YT45IKUdp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     "]]}, 
   {Hue[0.14213595499957954`, 0.6, 0.6], Dashing[{0.03, 0.}], 
    LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQPV2e++v//+/3M4DBB/tVh59dnbkewd+TfmibcTyC
n/WK9euDDe/gfP4H5l3SfAj+bdNHTe15b+F8w2MSP3IOvoHza0/aHrkvj+AH
sb/nOVPwGs73Xyqx8+WRV3C+0zaDPVNUEPz9jFetd5a9hPONDqQLZV95Aeef
uVfk42eK4H8w52Je3fEczudimSAw9fkzOH8d16JZPywQ/MpCnY7e3qdwvpX3
0jPr3z6B81vjV/V6OyD4x57NXVoy7zGcP3GFrJX4+0dwfvMpUaPXTgh+dvyf
Bp9FD+H8u3r5PupfHsD5roUX8voDEfyV6iEvA1PuI8L3ofy7cq57cP6vxhML
dhy/A+frTO/0eZN5G85fk2O9v0noFpwvqXHqvvGlG3D+zIjCn9fLrsP5bPlf
D0wzugbnH3TN8t/x5QqcP2Hi92tnZl+G870PJ/L8ibyEMD/riZXc3wtw/oq3
7Xrb8s4j0lO7RunX92fg/G/cv9ZKWZ+C8zljWp1KtxyH852nOZ7c+v0InC8V
eP/ubvdDcP6U9blz3nXvh/MdJ9YlGsrsgvMXcDHfu8exFRGfrV5l4vwb4HyH
Fc+fmgcthfMfvHKao1M3Dc7///3eL926NjjfK/XFxQMvQ/fB+ADrxTOd
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction:>Identity,
  Frame->True,
  FrameLabel->{
    FormBox["\"\[Mu]\"", TraditionalForm], 
    FormBox["\"x\"", TraditionalForm]},
  ImageSize->500,
  PlotLabel->FormBox["\"Subcritical Hopf\"", TraditionalForm],
  PlotRange->{{-2, 2}, {-1.5, 1.5}},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.5455553919375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"plot3", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Mu]", ",", "0", ",", "2"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1.5"}], ",", "1.5"}], "}"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLabel", "\[Rule]", "\"\<Subcritical Hopf\>\""}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<\[Mu]\>\"", ",", "\"\<x\>\""}], "}"}]}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
    RowBox[{"DisplayFunction", "\[Rule]", "Identity"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Dashing", "[", 
        RowBox[{"{", 
         RowBox[{"0.03", ",", "0.03"}], "}"}], "]"}], ",", 
       RowBox[{"Dashing", "[", 
        RowBox[{"{", 
         RowBox[{"0.03", ",", "0.00"}], "}"}], "]"}]}], "}"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{3.545555106546875*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], Dashing[{0.03, 0.03}], LineBox[CompressedData["
1:eJxF0HssFAAcB/DDNco6Tg87wk5UXjFJSaVikUfNo8nympCuF7KVVtO1O8kj
1kzK+5HSjSN31nJi3GzMI44d7dzp3HScZznXkbtqq9/vt3333ee/737UuNsh
CboEAiHoT/62f4J8uHM24STh3xG9zZIlFB+v/z5UUVzaQgkDBwwI35dR4sHh
8ar255Q08KTzE+88CgNcuetCZjalEEw3aNn/lFILvhRRxV5e4YANtfRIX8sO
sG3worw7hw++O+jhVbzaCzblkMU6OkPgVql3/9DxEXAXrcw8Yn4UrNx3wqjh
phCsq2YZm9t+AbtrY1tDG0XgfobbYI+9BGxVoFDXL06BFSqJeMxFCq6da+sj
PZsGkyzeLMlkMnDuNW5ipc0MeO0US5aU8Q2c5srn7O6WgyWN/Jxh6hx4gzZa
YndfAXY4ra9JbJsH+1ZTrzabLuK/LGKsv0YugR3nLxoKg5bBO4yWDfjraGJH
CXtv6Qr4ulvbxNaA72DWubjKT2topcLMeKboB5gb6qtX6LMKzvBjVnBm0NRJ
//EaphJ87AijkOK6Bo60HFLrCNDKvjxpMl0FLiZGp4XY/MT9Ym61Lh+95SE9
zCNFDSbUR7OlJuvg1FfsPJMudLtDlgH51gaY7J/q+Jj0Cyxy+ixI56Gbyr1s
ZNGb4Ci2O9lCg37ErKKL3mnADXKLElKgFpxVxowVn0fHhyzYNgaj9/B4TUHh
6Oz8yz25cegk95cr29LR1oydfvp1aM3RB9uFb9ETC9MjdSx0QXhL1NlmtNY+
5A6ThxYN55frCdAfMlVXBGPoQs8Yu5pxdMDrg5wzYvTHewO99Fl0kdPh/OB5
dIq0NIy6hD4QeEPSuYom6ozWFqjQU1xPWuw6mkercXbZRL+wMlRqtejfswdC
7w==
     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], Dashing[{0.03, 0.}], 
    LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ7ZX64uKBl6l2DGDwwX6BqH9bl+QUexi/kWOzeqfk
Ejg/InLh+g8ft8D53P8bY9zl9sP5qoHvXhzuPgLnl5+ztJ/x5SScL75F8B4j
43k4f9sj5zPnbS7B+Yey5kpHvrkC539Vs+Vfm3sdzmf6uVpAWvUWnG/2P2Fb
8Lo7cP6ZFpNzx7Tuw/nyE17/XPnuAZz/+vv9e1cNHsH5S17tPsXX9xjO55Nd
/v7Jkydwfk/m1rQFKs/g/G8Oq59k1D+H80uMjmwRO/wCzr+/7kj3RcVXcP7v
rCuzNatew/najuz/0na/gfPdFymmbxR/hwgv2XilhzHv4XydN6Hc130/wPnC
/B84jvxC8Fn2z16vPOcjnJ9tsvsmp/cnOH+1Z9KCfd8Q/K+vpQSeTfsM528N
dmee4vIFzq/3aJ2/5RmCr3jX68bi1q9wvpV5yxRJo29wfozc+Z+MlxH8r6d6
HxU0fofzZ7DElQSp/EC4/97WRUxHEHzW2sYQy8KfcD7Dyrj1j4R+wflFs9b3
Ch1C8Pdqd3AI5v2G8wW9inSa+P7A+Xd0L1yu3IPgb5hnr/Ik7i+cH7veTFD2
H4Lf0Lqw8c6qf3D+2heys/l8/sP5Si0iHuzLEPzp8txf//9H8AHvfRTH
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction:>Identity,
  Frame->True,
  FrameLabel->{
    FormBox["\"\[Mu]\"", TraditionalForm], 
    FormBox["\"x\"", TraditionalForm]},
  PlotLabel->FormBox["\"Subcritical Hopf\"", TraditionalForm],
  PlotRange->{{-2, 2}, {-1.5, 1.5}},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.5455553931875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"plot1", ",", "plot2", ",", "plot3"}], "}"}], ",", 
   RowBox[{"DisplayFunction", "\[Rule]", "$DisplayFunction"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{3.545555111421875*^9}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], Dashing[{0.03, 0.}], LineBox[CompressedData["
1:eJxN0XlI0wEUB/ClM11mmatpGuEidZV4H0uSJYKaoOhwpjkip3ZK08qseWaJ
HWsplSW1ctHSCrVbzeaKdKGJR2SiloiZ6Gymrh1eWwXx++7B4/GBL99/Hp3H
Z6eZkUikqL/773ZcKZ43Go1y0v/hGqx4zQb4Z7qwLXcJtom8enNuHo4mSwLU
Grj71JtjY5Nwb7Ja2dEHD/kmD1bUwf6aIkFGAmw57dRqYwmrHDPfhdYbCDuk
rMx9tQ9uHt048ms1/PBs9vL9DUuEq9jCryd4sHOSw95IO3ioUCnmNi0Sth/2
veB/GE7lb3etcoS1TsVnOC0LhM3NIs63H4c5FrFRuRvg10xai0IxT/iWlD3W
dxJ+69mrcHGGk9Wd7KCuOcJhn1eJL2XDrB8rKrLo8HPP/J2uPXrC6TcCH1AF
cCXzYP0HBjxO4QjW9usIZ+lLFsRFcJ6zD2PKG25L20TNGdAS3jLYWVd5DiZf
nNUJ/eDN8VzDy28awvKk4CdSIXy0bIDqEQzzRmX+6rHfhHsyHMwLyuFix0ZR
OAt+sdTd+kWlxj9spbUGMZwXIuekhMMFj2OqRdpZwgofRqP2DkxXNuXoImDd
gGKiWT9D2G7CnvZeAld7Dasux8Cx1anZMySYFewpL3s0jbx15jN9IhzkLesq
TYA74ikqxm54RiJxS4wzyTM/3W6Mhj+m+pYIQuEpmSZp0R0u/B5y+to22I4i
KnffCgfGufZw3UzyyvgwGR1eY9/glU+D7+8gR9PWwQG8mCO1VHhPzbh0yBa+
F7reiWUN+x1KY/ZRYIXoKYdvBU/27yq9awHnG6/XBJJhW5eR9i4zk/5Ij/ED
y0z6MwQWJBL8B7FSaL4=
      "]]}, 
    {Hue[0.9060679774997897, 0.6, 0.6], Dashing[{0.03, 0.}], 
     LineBox[CompressedData["
1:eJwVlHs0lHkcxmeLGJa10VRDSbtum6KilOx3yznCOXXKccmSXaK7aJdlh6Qi
XcRIW6lGrt32MK1Icvl2HblkELlVp9PKlmJ/7/vO+45hmH33j+95zuc5z3nO
89fXJjLWP3qGQCDYxN//2paTMaHT6TAvOieqoJCDsGnDyMZpHcrLR+VOPH/e
n9WcMqXDgRQzzf2rHJj45V3UTOiw0rEkvbeAg816RasYVodCU02amYyDjqT6
X4Y/6TA82df0aD4HPRHMSFuvDuOMpJIdZzl4szJiMF+uwy6TDWet0zlwY49K
4rbpMG2Xn8vsaA4MiOVTEwMd+rZtz/y8kYNR8cGHXjXTeDHPWui6hIN5O75M
ufvzNAYrOkzfGXPQOLTw3b9fTWNAzAtl6hgLN48lztp5bwoXWD/QJrWzcN0/
61V85BQ+STh2c6CChUWh88L9Zk/hLklJzopcFt6kjcjC6rTYRkHpYBwLc9+u
POm2V4s+Ho/OpPqzEBW7xu66WIsGD6uXSl1Z4CwzjgQ+mcTsl6aRw+YszJzh
c6Ll10k0Lbnl9j2rgkD9rZtSrCbR/d5ucccLFdx3Fz1RKCawXms93lypgstl
/sO9v03g4kw/5fM8FTxw7lHYLprAPi43ceqgCiKYdv+1Sg2GHKAtPPxV4N1t
KjudqMGmTiPlRWcVwHuj/AQbDTIh7U+3m6jgjnPqD3ad4/iq3vv2mlEG9l9Y
fc1cMo7SI0MPbVsYKHTfXdPkMI6HiwtnLb3JwAdhoMSiX41WTPys0hMMJIxn
TsqOqlEQLDkrjmbg0KIVDmPL1fjP2pd11V4MNEcvNk8e4PAS3Xd8gzUDjoPt
8sJ0Dgu0CefcJmnQO0Wrs1w5DO2yjA7up+HboLDp6tcszn9vURFcRQOGet4u
y2LR45FF3OlcGg7kDpgv82TxvGrn22WxNEQONbgxwyocc1ggv+JLQ2fcvJmH
z6vQqjy80MeOhgxxbfZGUOHl5A79Ch0FVVMdT1+OMljdbScNGqSAMyurmJYx
GKBwtIqpoeDQegzcsZHB+3pVrK2UgsN/brmRzdF4UhRwbOk+ChQrHGq5Aho9
L5CuxxsosBmpS1b70NgX0dJeK6ZAPaD42DhOYeEpZz1jlsDsj3NFj4so/OR3
LUHZSuCGy9vRM1so3O9oVqoqJbD1RlQiJaDw0rOxjPRUAuDpjLm3CIYn1bjs
DeDzxgcrx0MIlgwPtTQ4EVi7vEEp3UawuzGhyZjntiDhqEMwwcxn4fUhSwhQ
RUX2IQEEj6e45bCOfN6960rtZoIx8v4+J3sCrVErMyVeBFs7F07m2xAYa2BD
tU4Et3nJ4g+ICKT9vf73c0sIvhJ5S+rm8PuF2eedviO4x9w+yZDn1QF2nWH2
BDWJZ8KKzfn8SJB3gw1BOl7Z1GNG4Ou591xSRQRnVnnZexgTKF2nt1k0h+DH
NpU804jAqsgt+yrMCcbffe7SLSTwY/mHsjdmBHNf0+IYQwLFXvMtwZhgj2xU
WqBPwHVPtHuvkN//04OBET0Ciuy/AmMNCarllVaref7U7yu9qk+wpo86oZxB
IFX3RznvY7Ns3R1Lns1s37XwPh5pLe7Z9QXf77fsA69YH/wNuSPg++Mk+gIB
QbF7A//OCPwHo7OrvQ==
      "]]}, 
    {Hue[0.14213595499957954`, 0.6, 0.6], Dashing[{0.03, 0.03}], 
     LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQfaa/9df////3M4DBB/uriZ9fnbmO4N8zTrw9cz2C
b/q1qaogAsFn/yB9lJcdwX8rVXjQefs/OF8imadmWwKCv++J3KP3/Aj+yuZy
trQdf+H85UE9d0qSEHyFaIk4LyEE/17Dq7kxu//A+eIPjDtNsxD8lHxLteVS
CP436dbG0CO/4XxmJo+OU8UIfihroG+NDIK/y0LsyLFjv+D82UuDnl0vQ/AP
6F89pqqA4Cd+Phdkdf4nnO92hW9udzmCb/+Ua2apIoK/Wb/OQe3iDzg/Z7r5
MuEqBH+BRcb24xoI/gvO0CqRm9/h/NIf7b/nNiH4tQpGGu8MEfyTqUrC1be+
wfmat8+tX9CC4LN0ffreY4Lgq4TF/Nt69yucvz/adsPSHgQ/b+ItYT1bBD/p
yV7Tz8++wPkXCySY66ch+K1SO/vc7RH8LX8vHL329jMiPgSWrvs3F8Gvddwf
muyO4NevDljR9+0TnH/MSGPnt3kIvuKr3dXfPRD877eOvdz34yOcL/RSXOzw
QgR/hcGDt70BCH7gipTyjwwIvr2t/v6Jqz4g1HMXbvoRieC/2/s1+o8Ogm9S
UMUKpOF8AGPHN7w=
      "]]}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], Dashing[{0.03, 0.}], LineBox[CompressedData["
1:eJxF1HtI01EUB/CVq2xKPiA106SwHGWiW2o4A12o1JYvMisCX9l0vma1VZA/
fLRmhq98YVmYNTDNTSjHLGk+hub4QWY+M3+bpnPztSyXOjQrqHMvHC6ff+6B
c7/37o/PiEzcSiKRzvypv3uVi4Vxc9OgIP1b8nUb5e0N5JFRh7I1E7Jj+SGv
H0bkGnNmmnYOuXbp5jQ+jNzQpR2sliK3cTpl9Bhk7uw2o6Z5EWyl8S3Yuwt5
zHsyV5S+APbqdlhN7ZgHZ/WeUKpdkCN3GCxx3hw4TOzQqlfOgpkyz7ZyV2TF
lkFGq0APprVzbFMGdGCcuMoO9Ub+5ksxa8yfAVPIJdYVM1qwhFL3cPU48q1M
9/zCwmmwH0uMSxemwMKYhkJWAHK39rH4+pOv4NJ6Zz97wyQ4T7WbNsdETolZ
z2bXTYDHPTLYbssacFBmX3pxBPILt7P6iMtqNN8Jl8UbFAJsynlfK+/5Anav
useeTx4Dv0xlKHJtP4P3UFVqev8IuPp85tqwYBi8PcPYXkkbAncEccPkywPg
ktKVIfzRJzCrK85y/UI/Op875bdvow9cvyDykKV/QHkSUflGAw7+aWFqcmSo
wDsvCZn81z3gk5WBvS0rSpTnCPX425BOcLk0rWbxvgIcWIrFeTm9QfmmmBGE
eQu6T+Fpgb1VMzigfmbaN1IM1swya9yxSnByGNtAd0X+/iqKyVBVgMlZSbpT
dshUq6JjHEkZmEcfxZ8SJeDNFcJ0FLsLtu5YqvVXCcEHCsghLDvkYKfDZUmS
PHBRAP/IMyIb7G9rL/fEBODY5/7kUDs++I5PfHiK5Bp6HxebdGKCB5YFi2g+
2BXwL26/iidJQP2LnRMaiVj0P0g5boHYOTTP1Y1oGREOfpBDtYnGgsEJBxum
cjEf8OlE3cd2fdS7//4NyFZggg==
      "]]}, 
    {Hue[0.9060679774997897, 0.6, 0.6], Dashing[{0.03, 0.03}], 
     LineBox[CompressedData["
1:eJwVkHk4FAgfgNlBJdHtCmUlrHxuG/JDH/mwFZuS2ijKoHHkqv2YT45IKUdp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      "]]}, 
    {Hue[0.14213595499957954`, 0.6, 0.6], Dashing[{0.03, 0.}], 
     LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQPV2e++v//+/3M4DBB/tVh59dnbkewd+TfmibcTyC
n/WK9euDDe/gfP4H5l3SfAj+bdNHTe15b+F8w2MSP3IOvoHza0/aHrkvj+AH
sb/nOVPwGs73Xyqx8+WRV3C+0zaDPVNUEPz9jFetd5a9hPONDqQLZV95Aeef
uVfk42eK4H8w52Je3fEczudimSAw9fkzOH8d16JZPywQ/MpCnY7e3qdwvpX3
0jPr3z6B81vjV/V6OyD4x57NXVoy7zGcP3GFrJX4+0dwfvMpUaPXTgh+dvyf
Bp9FD+H8u3r5PupfHsD5roUX8voDEfyV6iEvA1PuI8L3ofy7cq57cP6vxhML
dhy/A+frTO/0eZN5G85fk2O9v0noFpwvqXHqvvGlG3D+zIjCn9fLrsP5bPlf
D0wzugbnH3TN8t/x5QqcP2Hi92tnZl+G870PJ/L8ibyEMD/riZXc3wtw/oq3
7Xrb8s4j0lO7RunX92fg/G/cv9ZKWZ+C8zljWp1KtxyH852nOZ7c+v0InC8V
eP/ubvdDcP6U9blz3nXvh/MdJ9YlGsrsgvMXcDHfu8exFRGfrV5l4vwb4HyH
Fc+fmgcthfMfvHKao1M3Dc7///3eL926NjjfK/XFxQMvQ/fB+ADrxTOd
      "]]}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], Dashing[{0.03, 0.03}], LineBox[CompressedData["
1:eJxF0HssFAAcB/DDNco6Tg87wk5UXjFJSaVikUfNo8nympCuF7KVVtO1O8kj
1kzK+5HSjSN31nJi3GzMI44d7dzp3HScZznXkbtqq9/vt3333ee/737UuNsh
CboEAiHoT/62f4J8uHM24STh3xG9zZIlFB+v/z5UUVzaQgkDBwwI35dR4sHh
8ar255Q08KTzE+88CgNcuetCZjalEEw3aNn/lFILvhRRxV5e4YANtfRIX8sO
sG3worw7hw++O+jhVbzaCzblkMU6OkPgVql3/9DxEXAXrcw8Yn4UrNx3wqjh
phCsq2YZm9t+AbtrY1tDG0XgfobbYI+9BGxVoFDXL06BFSqJeMxFCq6da+sj
PZsGkyzeLMlkMnDuNW5ipc0MeO0US5aU8Q2c5srn7O6WgyWN/Jxh6hx4gzZa
YndfAXY4ra9JbJsH+1ZTrzabLuK/LGKsv0YugR3nLxoKg5bBO4yWDfjraGJH
CXtv6Qr4ulvbxNaA72DWubjKT2topcLMeKboB5gb6qtX6LMKzvBjVnBm0NRJ
//EaphJ87AijkOK6Bo60HFLrCNDKvjxpMl0FLiZGp4XY/MT9Ym61Lh+95SE9
zCNFDSbUR7OlJuvg1FfsPJMudLtDlgH51gaY7J/q+Jj0Cyxy+ixI56Gbyr1s
ZNGb4Ci2O9lCg37ErKKL3mnADXKLElKgFpxVxowVn0fHhyzYNgaj9/B4TUHh
6Oz8yz25cegk95cr29LR1oydfvp1aM3RB9uFb9ETC9MjdSx0QXhL1NlmtNY+
5A6ThxYN55frCdAfMlVXBGPoQs8Yu5pxdMDrg5wzYvTHewO99Fl0kdPh/OB5
dIq0NIy6hD4QeEPSuYom6ozWFqjQU1xPWuw6mkercXbZRL+wMlRqtejfswdC
7w==
      "]]}, 
    {Hue[0.9060679774997897, 0.6, 0.6], Dashing[{0.03, 0.}], 
     LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ7ZX64uKBl6l2DGDwwX6BqH9bl+QUexi/kWOzeqfk
Ejg/InLh+g8ft8D53P8bY9zl9sP5qoHvXhzuPgLnl5+ztJ/x5SScL75F8B4j
43k4f9sj5zPnbS7B+Yey5kpHvrkC539Vs+Vfm3sdzmf6uVpAWvUWnG/2P2Fb
8Lo7cP6ZFpNzx7Tuw/nyE17/XPnuAZz/+vv9e1cNHsH5S17tPsXX9xjO55Nd
/v7Jkydwfk/m1rQFKs/g/G8Oq59k1D+H80uMjmwRO/wCzr+/7kj3RcVXcP7v
rCuzNatew/najuz/0na/gfPdFymmbxR/hwgv2XilhzHv4XydN6Hc130/wPnC
/B84jvxC8Fn2z16vPOcjnJ9tsvsmp/cnOH+1Z9KCfd8Q/K+vpQSeTfsM528N
dmee4vIFzq/3aJ2/5RmCr3jX68bi1q9wvpV5yxRJo29wfozc+Z+MlxH8r6d6
HxU0fofzZ7DElQSp/EC4/97WRUxHEHzW2sYQy8KfcD7Dyrj1j4R+wflFs9b3
Ch1C8Pdqd3AI5v2G8wW9inSa+P7A+Xd0L1yu3IPgb5hnr/Ik7i+cH7veTFD2
H4Lf0Lqw8c6qf3D+2heys/l8/sP5Si0iHuzLEPzp8txf//9H8AHvfRTH
      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox["\"\[Mu]\"", TraditionalForm], 
    FormBox["\"x\"", TraditionalForm]},
  ImageSize->500,
  PlotLabel->FormBox["\"Subcritical Hopf\"", TraditionalForm],
  PlotRange->{{-2, 2}, {-1.5, 1.5}},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.545555395234375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"20", " ", 
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"-", "t"}], "/", "9"}], "]"}]}], "+", "30"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "100"}], "}"}], ",", " ", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", " ", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "20"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5814085967274017`*^9, 3.581408758495654*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV1nk4VG0YBnCKEIoWa0XIljQk+cSZe8a+b2NMCFHIln0vSpEWS/WVRCoS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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->{0, 20},
  Method->{},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.5814087416606913`*^9, 3.5814087593597035`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"20", " ", 
     RowBox[{"Exp", "[", 
      RowBox[{"-", 
       FractionBox["t", "9"]}], "]"}]}], "+", "30"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "100"}], "}"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"RGBColor", "[", 
     RowBox[{"0.05`", ",", "0.05`", ",", "0.05`"}], "]"}]}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "20"}], "}"}]}]}], "]"}]], "Input",
 NumberMarks->False],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[0.05, 0.05, 0.05], LineBox[CompressedData["
1:eJwV1nk4VG0YBnCKEIoWa0XIljQk+cSZe8a+b2NMCFHIln0vSpEWS/WVRCoS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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->{0, 20},
  Method->{},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.581408785839218*^9}]
}, Open  ]]
},
WindowSize->{1912, 958},
WindowMargins->{{0, Automatic}, {Automatic, -28}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (November 20, 2012)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 1085, 32, 109, "Input"],
Cell[CellGroupData[{
Cell[1655, 56, 36, 0, 45, "Input"],
Cell[1694, 58, 78, 1, 44, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1809, 64, 146, 3, 45, "Input"],
Cell[1958, 69, 153, 3, 44, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2148, 77, 106, 3, 45, "Input"],
Cell[2257, 82, 149, 4, 44, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2443, 91, 1653, 46, 249, "Input"],
Cell[4099, 139, 3972, 76, 522, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8108, 220, 1592, 43, 220, "Input"],
Cell[9703, 265, 4767, 88, 522, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14507, 358, 1305, 36, 162, "Input"],
Cell[15815, 396, 2264, 45, 393, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18116, 446, 255, 7, 45, "Input"],
Cell[18374, 455, 10057, 182, 522, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28468, 642, 504, 14, 45, "Input"],
Cell[28975, 658, 7453, 128, 363, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[36465, 791, 578, 17, 71, "Input"],
Cell[37046, 810, 7432, 128, 395, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
