(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     21758,        519]
NotebookOptionsPosition[     20796,        481]
NotebookOutlinePosition[     21140,        496]
CellTagsIndexPosition[     21097,        493]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"setstate", "[", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}], "]"}], ";", 
  RowBox[{"setparm", "[", 
   RowBox[{"{", "\[Mu]", "}"}], "]"}], ";", 
  RowBox[{"slopevec", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"\[Mu]", " ", "x"}], " ", "+", " ", 
      SuperscriptBox["x", "3"]}], ",", 
     RowBox[{"-", " ", "y"}]}], "}"}]}], ";", 
  RowBox[{"sysname", "=", "\"\<Subcritical Pitchfork\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eq1", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], ";", 
  RowBox[{"eq2", "=", 
   RowBox[{"{", 
    RowBox[{
     SqrtBox[
      RowBox[{"-", "\[Mu]"}]], ",", "0"}], "}"}]}], ";", 
  RowBox[{"eq3", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      SqrtBox[
       RowBox[{"-", "\[Mu]"}]]}], ",", "0"}], "}"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eigsys", "[", "eq1", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"eigsys", "[", 
  RowBox[{"{", 
   RowBox[{"0", ",", "0"}], "}"}], "]"}]], "Output",
 CellChangeTimes->{3.545554632875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eigsys", "[", "eq2", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"eigsys", "[", 
  RowBox[{"{", 
   RowBox[{
    SqrtBox[
     RowBox[{"-", "\[Mu]"}]], ",", "0"}], "}"}], "]"}]], "Output",
 CellChangeTimes->{3.54555463375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eigsys", "[", "eq3", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"eigsys", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", 
     SqrtBox[
      RowBox[{"-", "\[Mu]"}]]}], ",", "0"}], "}"}], "]"}]], "Output",
 CellChangeTimes->{3.545554634546875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"plot1", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", 
      SqrtBox[
       RowBox[{"-", "\[Mu]"}]], ",", 
      RowBox[{"-", 
       SqrtBox[
        RowBox[{"-", "\[Mu]"}]]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Mu]", ",", 
      RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLabel", "\[Rule]", "\"\<Subcritical Pitchfork\>\""}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<\[Mu]\>\"", ",", "\"\<x\>\""}], "}"}]}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "imsize"}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Dashing", "[", 
        RowBox[{"{", 
         RowBox[{"0.1", ",", "0"}], "}"}], "]"}], ",", 
       RowBox[{"Dashing", "[", 
        RowBox[{"{", 
         RowBox[{"0.03", ",", "0.03"}], "}"}], "]"}], ",", 
       RowBox[{"Dashing", "[", 
        RowBox[{"{", 
         RowBox[{"0.03", ",", "0.03"}], "}"}], "]"}]}], "}"}]}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"DisplayFunction", " ", "\[Rule]", "Identity"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{3.545554560203125*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], Dashing[{0.1, 0}], LineBox[CompressedData["
1:eJxF1HtI01EUB/CVq2xKPiA106SwHGWiW2o4A12o1JYvMisCX9l0vma1VZA/
fLRmhq98YVmYNTDNTSjHLGk+hub4QWY+M3+bpnPztSyXOjQrqHMvHC6ff+6B
c7/37o/PiEzcSiKRzvypv3uVi4Vxc9OgIP1b8nUb5e0N5JFRh7I1E7Jj+SGv
H0bkGnNmmnYOuXbp5jQ+jNzQpR2sliK3cTpl9Bhk7uw2o6Z5EWyl8S3Yuwt5
zHsyV5S+APbqdlhN7ZgHZ/WeUKpdkCN3GCxx3hw4TOzQqlfOgpkyz7ZyV2TF
lkFGq0APprVzbFMGdGCcuMoO9Ub+5ksxa8yfAVPIJdYVM1qwhFL3cPU48q1M
9/zCwmmwH0uMSxemwMKYhkJWAHK39rH4+pOv4NJ6Zz97wyQ4T7WbNsdETolZ
z2bXTYDHPTLYbssacFBmX3pxBPILt7P6iMtqNN8Jl8UbFAJsynlfK+/5Anav
useeTx4Dv0xlKHJtP4P3UFVqev8IuPp85tqwYBi8PcPYXkkbAncEccPkywPg
ktKVIfzRJzCrK85y/UI/Op875bdvow9cvyDykKV/QHkSUflGAw7+aWFqcmSo
wDsvCZn81z3gk5WBvS0rSpTnCPX425BOcLk0rWbxvgIcWIrFeTm9QfmmmBGE
eQu6T+Fpgb1VMzigfmbaN1IM1swya9yxSnByGNtAd0X+/iqKyVBVgMlZSbpT
dshUq6JjHEkZmEcfxZ8SJeDNFcJ0FLsLtu5YqvVXCcEHCsghLDvkYKfDZUmS
PHBRAP/IMyIb7G9rL/fEBODY5/7kUDs++I5PfHiK5Bp6HxebdGKCB5YFi2g+
2BXwL26/iidJQP2LnRMaiVj0P0g5boHYOTTP1Y1oGREOfpBDtYnGgsEJBxum
cjEf8OlE3cd2fdS7//4NyFZggg==
     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], Dashing[{0.03, 0.03}], 
    LineBox[CompressedData["
1:eJwVkHk4FAgfgNlBJdHtCmUlrHxuG/JDH/mwFZuS2ijKoHHkqv2YT45IKUdp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     "]]}, 
   {Hue[0.14213595499957954`, 0.6, 0.6], Dashing[{0.03, 0.03}], 
    LineBox[CompressedData["
1:eJwV0Hk4FIoexnHOUJJoJ0I5Eo5cjOWEhC65OBU3kboolSmNpUKdy1xZokVZ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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction:>Identity,
  Frame->True,
  FrameLabel->{
    FormBox["\"\[Mu]\"", TraditionalForm], 
    FormBox["\"x\"", TraditionalForm]},
  ImageSize->360,
  PlotLabel->FormBox["\"Subcritical Pitchfork\"", TraditionalForm],
  PlotRange->{{-1, 1}, {-1, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.54555463546875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"plot2", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", "0", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Mu]", ",", "0", ",", "1"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLabel", "\[Rule]", "\"\<Subcritical Pitchfork\>\""}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<\[Mu]\>\"", ",", "\"\<x\>\""}], "}"}]}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
    RowBox[{"DisplayFunction", "\[Rule]", "Identity"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "imsize"}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Dashing", "[", 
       RowBox[{"{", 
        RowBox[{"0.03", ",", "0.03"}], "}"}], "]"}], "}"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{3.545554567484375*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], Dashing[{0.03, 0.03}], LineBox[CompressedData["
1:eJxF0H0s1AEYB/A7rlHW6fRiPzp2ovIWk5RUKhZ5qXmbLG8T0vWGbKXVdM1J
XmLtJuX9JaUbR+6scmLctMz7EYo7ziXceducGy1XbfU8z/bdd5//vnsYUTf9
Y7RIJJLvn/xtr5iZ/tbZoBOkf0dxM4qXEo6u/32wJL+wgXAHe3cPvy0iAsHB
0ermp0Q0eNzukVs2kQQu3Xk+LYNIBbN0G/Y9JjjgCyFlvKXlSrCehhXqYcID
W/gtzLRn8sG3e5xd81fegw35NAmZ3AJulLl19R5rA7cxi4xDlCKwau9x/Zrr
n8Baa9xtxhadYCdNZGNAbRe4K9Wxp8OqF2yaq1irXugDK9RSyZD9ALhyrqmT
+kQMptJfLcrlg+CsK4LYUvMv4NWTXHlcyjA4yUHE39U+ApbWijL7GV/BP5mD
BZZ3v4GtT+lsxDaNgT3KGZfrDSX4L3qE2WSoFGyjDNIb9p0Ab9df0hWtoykt
Bbw9hZPgq45No5u9ZWDu2ajSj6tolcJo23TeFFgQ4KHNcZeDUzzZJfxpNGPc
a6SC/R189HAqh3CYBoea9K6RxWhVZ7YsnvUDnE8JT/I3n8H9EkG5lgi96T4r
0DlhFkyqDufJDObAiS942QZt6GbrdF3aDQWY5pVo85CqBI/Z9omThei6Yldz
efg8OIznRKNvoB+wy1hjbxbANTP0AqrPIji9iB0pOYeO9p+3qPVD7xYK63yD
0Rk5FzuyotBxTs+XtySjzVJ3eOpUoTeO3Ns6/Bo9Oj81UMVF5wY3hJ2pR2us
/G+xheix/pxibTH6XZr6kngIzXGJsKwYQXu/PMA/LUF/uNP9mTWLzrM9lOOn
RCfICgMZi+j9PtekrStoCnmwMleNnhC4MCPX0UJmhZ39L/QzUz2VRoP+DRRC
Ph8=
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction:>Identity,
  Frame->True,
  FrameLabel->{
    FormBox["\"\[Mu]\"", TraditionalForm], 
    FormBox["\"x\"", TraditionalForm]},
  ImageSize->360,
  PlotLabel->FormBox["\"Subcritical Pitchfork\"", TraditionalForm],
  PlotRange->{{-1, 1}, {-1, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.5455546369375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"plot1", ",", "plot2"}], "}"}], ",", 
   RowBox[{"DisplayFunction", "\[Rule]", "$DisplayFunction"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{3.54555457303125*^9}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], Dashing[{0.1, 0}], LineBox[CompressedData["
1:eJxF1HtI01EUB/CVq2xKPiA106SwHGWiW2o4A12o1JYvMisCX9l0vma1VZA/
fLRmhq98YVmYNTDNTSjHLGk+hub4QWY+M3+bpnPztSyXOjQrqHMvHC6ff+6B
c7/37o/PiEzcSiKRzvypv3uVi4Vxc9OgIP1b8nUb5e0N5JFRh7I1E7Jj+SGv
H0bkGnNmmnYOuXbp5jQ+jNzQpR2sliK3cTpl9Bhk7uw2o6Z5EWyl8S3Yuwt5
zHsyV5S+APbqdlhN7ZgHZ/WeUKpdkCN3GCxx3hw4TOzQqlfOgpkyz7ZyV2TF
lkFGq0APprVzbFMGdGCcuMoO9Ub+5ksxa8yfAVPIJdYVM1qwhFL3cPU48q1M
9/zCwmmwH0uMSxemwMKYhkJWAHK39rH4+pOv4NJ6Zz97wyQ4T7WbNsdETolZ
z2bXTYDHPTLYbssacFBmX3pxBPILt7P6iMtqNN8Jl8UbFAJsynlfK+/5Anav
useeTx4Dv0xlKHJtP4P3UFVqev8IuPp85tqwYBi8PcPYXkkbAncEccPkywPg
ktKVIfzRJzCrK85y/UI/Op875bdvow9cvyDykKV/QHkSUflGAw7+aWFqcmSo
wDsvCZn81z3gk5WBvS0rSpTnCPX425BOcLk0rWbxvgIcWIrFeTm9QfmmmBGE
eQu6T+Fpgb1VMzigfmbaN1IM1swya9yxSnByGNtAd0X+/iqKyVBVgMlZSbpT
dshUq6JjHEkZmEcfxZ8SJeDNFcJ0FLsLtu5YqvVXCcEHCsghLDvkYKfDZUmS
PHBRAP/IMyIb7G9rL/fEBODY5/7kUDs++I5PfHiK5Bp6HxebdGKCB5YFi2g+
2BXwL26/iidJQP2LnRMaiVj0P0g5boHYOTTP1Y1oGREOfpBDtYnGgsEJBxum
cjEf8OlE3cd2fdS7//4NyFZggg==
      "]]}, 
    {Hue[0.9060679774997897, 0.6, 0.6], Dashing[{0.03, 0.03}], 
     LineBox[CompressedData["
1:eJwVkHk4FAgfgNlBJdHtCmUlrHxuG/JDH/mwFZuS2ijKoHHkqv2YT45IKUdp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      "]]}, 
    {Hue[0.14213595499957954`, 0.6, 0.6], Dashing[{0.03, 0.03}], 
     LineBox[CompressedData["
1:eJwV0Hk4FIoexnHOUJJoJ0I5Eo5cjOWEhC65OBU3kboolSmNpUKdy1xZokVZ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      "]]}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], Dashing[{0.03, 0.03}], LineBox[CompressedData["
1:eJxF0H0s1AEYB/A7rlHW6fRiPzp2ovIWk5RUKhZ5qXmbLG8T0vWGbKXVdM1J
XmLtJuX9JaUbR+6scmLctMz7EYo7ziXceducGy1XbfU8z/bdd5//vnsYUTf9
Y7RIJJLvn/xtr5iZ/tbZoBOkf0dxM4qXEo6u/32wJL+wgXAHe3cPvy0iAsHB
0ermp0Q0eNzukVs2kQQu3Xk+LYNIBbN0G/Y9JjjgCyFlvKXlSrCehhXqYcID
W/gtzLRn8sG3e5xd81fegw35NAmZ3AJulLl19R5rA7cxi4xDlCKwau9x/Zrr
n8Baa9xtxhadYCdNZGNAbRe4K9Wxp8OqF2yaq1irXugDK9RSyZD9ALhyrqmT
+kQMptJfLcrlg+CsK4LYUvMv4NWTXHlcyjA4yUHE39U+ApbWijL7GV/BP5mD
BZZ3v4GtT+lsxDaNgT3KGZfrDSX4L3qE2WSoFGyjDNIb9p0Ab9df0hWtoykt
Bbw9hZPgq45No5u9ZWDu2ajSj6tolcJo23TeFFgQ4KHNcZeDUzzZJfxpNGPc
a6SC/R189HAqh3CYBoea9K6RxWhVZ7YsnvUDnE8JT/I3n8H9EkG5lgi96T4r
0DlhFkyqDufJDObAiS942QZt6GbrdF3aDQWY5pVo85CqBI/Z9omThei6Yldz
efg8OIznRKNvoB+wy1hjbxbANTP0AqrPIji9iB0pOYeO9p+3qPVD7xYK63yD
0Rk5FzuyotBxTs+XtySjzVJ3eOpUoTeO3Ns6/Bo9Oj81UMVF5wY3hJ2pR2us
/G+xheix/pxibTH6XZr6kngIzXGJsKwYQXu/PMA/LUF/uNP9mTWLzrM9lOOn
RCfICgMZi+j9PtekrStoCnmwMleNnhC4MCPX0UJmhZ39L/QzUz2VRoP+DRRC
Ph8=
      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox["\"\[Mu]\"", TraditionalForm], 
    FormBox["\"x\"", TraditionalForm]},
  ImageSize->360,
  PlotLabel->FormBox["\"Subcritical Pitchfork\"", TraditionalForm],
  PlotRange->{{-1, 1}, {-1, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.545554638015625*^9}]
}, Open  ]]
},
WindowSize->{1272, 679},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"7.0 for Microsoft Windows (32-bit) (November 10, 2008)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 477, 14, 33, "Input"],
Cell[1025, 36, 391, 15, 40, "Input"],
Cell[CellGroupData[{
Cell[1441, 55, 61, 1, 31, "Input"],
Cell[1505, 58, 146, 4, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1688, 67, 61, 1, 31, "Input"],
Cell[1752, 70, 184, 6, 37, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1973, 81, 61, 1, 31, "Input"],
Cell[2037, 84, 210, 7, 37, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2284, 96, 1594, 46, 127, "Input"],
Cell[3881, 144, 6421, 116, 263, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10339, 265, 1195, 31, 112, "Input"],
Cell[11537, 298, 1512, 32, 263, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13086, 335, 240, 7, 31, "Input"],
Cell[13329, 344, 7451, 134, 263, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
