(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     21387,        508]
NotebookOptionsPosition[     20428,        470]
NotebookOutlinePosition[     20772,        485]
CellTagsIndexPosition[     20729,        482]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"setstate", "[", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}], "]"}], ";", 
  RowBox[{"setparm", "[", 
   RowBox[{"{", "\[Mu]", "}"}], "]"}], ";", 
  RowBox[{"slopevec", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"\[Mu]", " ", "x"}], " ", "-", " ", 
      SuperscriptBox["x", "3"]}], ",", 
     RowBox[{"-", " ", "y"}]}], "}"}]}], ";", 
  RowBox[{"sysname", "=", "\"\<Supercritical Pitchfork\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eq1", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], ";", 
  RowBox[{"eq2", "=", 
   RowBox[{"{", 
    RowBox[{
     SqrtBox["\[Mu]"], ",", "0"}], "}"}]}], ";", 
  RowBox[{"eq3", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      SqrtBox["\[Mu]"]}], ",", "0"}], "}"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eigsys", "[", "eq1", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"eigsys", "[", 
  RowBox[{"{", 
   RowBox[{"0", ",", "0"}], "}"}], "]"}]], "Output",
 CellChangeTimes->{3.545554503640625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eigsys", "[", "eq2", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"eigsys", "[", 
  RowBox[{"{", 
   RowBox[{
    SqrtBox["\[Mu]"], ",", "0"}], "}"}], "]"}]], "Output",
 CellChangeTimes->{3.545554504515625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eigsys", "[", "eq3", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"eigsys", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", 
     SqrtBox["\[Mu]"]}], ",", "0"}], "}"}], "]"}]], "Output",
 CellChangeTimes->{3.545554505296875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"plot1", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", "0", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Mu]", ",", 
      RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLabel", "\[Rule]", "\"\<Supercritical Pitchfork\>\""}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<\[Mu]\>\"", ",", "\"\<x\>\""}], "}"}]}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "imsize"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"DisplayFunction", " ", "\[Rule]", "Identity"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{3.545554409625*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxF1HtI01EUB/CVq2xKPiA106SwHGWiW2o4A12o1JYvMisCX9l0vma1VZA/
fLRmhq98YVmYNTDNTSjHLGk+hub4QWY+M3+bpnPztSyXOjQrqHMvHC6ff+6B
c7/37o/PiEzcSiKRzvypv3uVi4Vxc9OgIP1b8nUb5e0N5JFRh7I1E7Jj+SGv
H0bkGnNmmnYOuXbp5jQ+jNzQpR2sliK3cTpl9Bhk7uw2o6Z5EWyl8S3Yuwt5
zHsyV5S+APbqdlhN7ZgHZ/WeUKpdkCN3GCxx3hw4TOzQqlfOgpkyz7ZyV2TF
lkFGq0APprVzbFMGdGCcuMoO9Ub+5ksxa8yfAVPIJdYVM1qwhFL3cPU48q1M
9/zCwmmwH0uMSxemwMKYhkJWAHK39rH4+pOv4NJ6Zz97wyQ4T7WbNsdETolZ
z2bXTYDHPTLYbssacFBmX3pxBPILt7P6iMtqNN8Jl8UbFAJsynlfK+/5Anav
useeTx4Dv0xlKHJtP4P3UFVqev8IuPp85tqwYBi8PcPYXkkbAncEccPkywPg
ktKVIfzRJzCrK85y/UI/Op875bdvow9cvyDykKV/QHkSUflGAw7+aWFqcmSo
wDsvCZn81z3gk5WBvS0rSpTnCPX425BOcLk0rWbxvgIcWIrFeTm9QfmmmBGE
eQu6T+Fpgb1VMzigfmbaN1IM1swya9yxSnByGNtAd0X+/iqKyVBVgMlZSbpT
dshUq6JjHEkZmEcfxZ8SJeDNFcJ0FLsLtu5YqvVXCcEHCsghLDvkYKfDZUmS
PHBRAP/IMyIb7G9rL/fEBODY5/7kUDs++I5PfHiK5Bp6HxebdGKCB5YFi2g+
2BXwL26/iidJQP2LnRMaiVj0P0g5boHYOTTP1Y1oGREOfpBDtYnGgsEJBxum
cjEf8OlE3cd2fdS7//4NyFZggg==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction:>Identity,
  Frame->True,
  FrameLabel->{
    FormBox["\"\[Mu]\"", TraditionalForm], 
    FormBox["\"x\"", TraditionalForm]},
  ImageSize->360,
  PlotLabel->FormBox["\"Supercritical Pitchfork\"", TraditionalForm],
  PlotRange->{{-1, 1}, {-1, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.54555450615625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"plot2", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      SqrtBox["\[Mu]"], ",", "0", ",", 
      RowBox[{"-", 
       SqrtBox["\[Mu]"]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Mu]", ",", "0", ",", "1"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLabel", "\[Rule]", "\"\<Supercritical Pitchfork\>\""}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<\[Mu]\>\"", ",", "\"\<x\>\""}], "}"}]}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
    RowBox[{"DisplayFunction", "\[Rule]", "Identity"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "imsize"}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Dashing", "[", 
        RowBox[{"{", 
         RowBox[{"0.1", ",", "0"}], "}"}], "]"}], ",", 
       RowBox[{"Dashing", "[", 
        RowBox[{"{", 
         RowBox[{"0.03", ",", "0.03"}], "}"}], "]"}], ",", 
       RowBox[{"Dashing", "[", 
        RowBox[{"{", 
         RowBox[{"0.1", ",", "0"}], "}"}], "]"}]}], "}"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{3.545554415671875*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], Dashing[{0.1, 0}], LineBox[CompressedData["
1:eJwVk3s01Ikbxl0Ku8SqbYtcDoZyzbbFVqtnpY1IReSSqFw2Ui4/l1TyExMq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     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], Dashing[{0.03, 0.03}], 
    LineBox[CompressedData["
1:eJxF0H0s1AEYB/A7rlHW6fRiPzp2ovIWk5RUKhZ5qXmbLG8T0vWGbKXVdM1J
XmLtJuX9JaUbR+6scmLctMz7EYo7ziXceducGy1XbfU8z/bdd5//vnsYUTf9
Y7RIJJLvn/xtr5iZ/tbZoBOkf0dxM4qXEo6u/32wJL+wgXAHe3cPvy0iAsHB
0ermp0Q0eNzukVs2kQQu3Xk+LYNIBbN0G/Y9JjjgCyFlvKXlSrCehhXqYcID
W/gtzLRn8sG3e5xd81fegw35NAmZ3AJulLl19R5rA7cxi4xDlCKwau9x/Zrr
n8Baa9xtxhadYCdNZGNAbRe4K9Wxp8OqF2yaq1irXugDK9RSyZD9ALhyrqmT
+kQMptJfLcrlg+CsK4LYUvMv4NWTXHlcyjA4yUHE39U+ApbWijL7GV/BP5mD
BZZ3v4GtT+lsxDaNgT3KGZfrDSX4L3qE2WSoFGyjDNIb9p0Ab9df0hWtoykt
Bbw9hZPgq45No5u9ZWDu2ajSj6tolcJo23TeFFgQ4KHNcZeDUzzZJfxpNGPc
a6SC/R189HAqh3CYBoea9K6RxWhVZ7YsnvUDnE8JT/I3n8H9EkG5lgi96T4r
0DlhFkyqDufJDObAiS942QZt6GbrdF3aDQWY5pVo85CqBI/Z9omThei6Yldz
efg8OIznRKNvoB+wy1hjbxbANTP0AqrPIji9iB0pOYeO9p+3qPVD7xYK63yD
0Rk5FzuyotBxTs+XtySjzVJ3eOpUoTeO3Ns6/Bo9Oj81UMVF5wY3hJ2pR2us
/G+xheix/pxibTH6XZr6kngIzXGJsKwYQXu/PMA/LUF/uNP9mTWLzrM9lOOn
RCfICgMZi+j9PtekrStoCnmwMleNnhC4MCPX0UJmhZ39L/QzUz2VRoP+DRRC
Ph8=
     "]]}, 
   {Hue[0.14213595499957954`, 0.6, 0.6], Dashing[{0.1, 0}], 
    LineBox[CompressedData["
1:eJwV0/k/FPgfwHFHxS6xatsi8XBWCNsWW63eK21EkitHQpGNlGNRU8lXTKhQ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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction:>Identity,
  Frame->True,
  FrameLabel->{
    FormBox["\"\[Mu]\"", TraditionalForm], 
    FormBox["\"x\"", TraditionalForm]},
  ImageSize->360,
  PlotLabel->FormBox["\"Supercritical Pitchfork\"", TraditionalForm],
  PlotRange->{{-1, 1}, {-1, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.5455545073125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"plot1", ",", "plot2"}], "}"}], ",", 
   RowBox[{"DisplayFunction", "\[Rule]", "$DisplayFunction"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{3.545554421484375*^9}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxF1HtI01EUB/CVq2xKPiA106SwHGWiW2o4A12o1JYvMisCX9l0vma1VZA/
fLRmhq98YVmYNTDNTSjHLGk+hub4QWY+M3+bpnPztSyXOjQrqHMvHC6ff+6B
c7/37o/PiEzcSiKRzvypv3uVi4Vxc9OgIP1b8nUb5e0N5JFRh7I1E7Jj+SGv
H0bkGnNmmnYOuXbp5jQ+jNzQpR2sliK3cTpl9Bhk7uw2o6Z5EWyl8S3Yuwt5
zHsyV5S+APbqdlhN7ZgHZ/WeUKpdkCN3GCxx3hw4TOzQqlfOgpkyz7ZyV2TF
lkFGq0APprVzbFMGdGCcuMoO9Ub+5ksxa8yfAVPIJdYVM1qwhFL3cPU48q1M
9/zCwmmwH0uMSxemwMKYhkJWAHK39rH4+pOv4NJ6Zz97wyQ4T7WbNsdETolZ
z2bXTYDHPTLYbssacFBmX3pxBPILt7P6iMtqNN8Jl8UbFAJsynlfK+/5Anav
useeTx4Dv0xlKHJtP4P3UFVqev8IuPp85tqwYBi8PcPYXkkbAncEccPkywPg
ktKVIfzRJzCrK85y/UI/Op875bdvow9cvyDykKV/QHkSUflGAw7+aWFqcmSo
wDsvCZn81z3gk5WBvS0rSpTnCPX425BOcLk0rWbxvgIcWIrFeTm9QfmmmBGE
eQu6T+Fpgb1VMzigfmbaN1IM1swya9yxSnByGNtAd0X+/iqKyVBVgMlZSbpT
dshUq6JjHEkZmEcfxZ8SJeDNFcJ0FLsLtu5YqvVXCcEHCsghLDvkYKfDZUmS
PHBRAP/IMyIb7G9rL/fEBODY5/7kUDs++I5PfHiK5Bp6HxebdGKCB5YFi2g+
2BXwL26/iidJQP2LnRMaiVj0P0g5boHYOTTP1Y1oGREOfpBDtYnGgsEJBxum
cjEf8OlE3cd2fdS7//4NyFZggg==
      "]]}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], Dashing[{0.1, 0}], LineBox[CompressedData["
1:eJwVk3s01Ikbxl0Ku8SqbYtcDoZyzbbFVqtnpY1IReSSqFw2Ui4/l1TyExMq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      "]]}, 
    {Hue[0.9060679774997897, 0.6, 0.6], Dashing[{0.03, 0.03}], 
     LineBox[CompressedData["
1:eJxF0H0s1AEYB/A7rlHW6fRiPzp2ovIWk5RUKhZ5qXmbLG8T0vWGbKXVdM1J
XmLtJuX9JaUbR+6scmLctMz7EYo7ziXceducGy1XbfU8z/bdd5//vnsYUTf9
Y7RIJJLvn/xtr5iZ/tbZoBOkf0dxM4qXEo6u/32wJL+wgXAHe3cPvy0iAsHB
0ermp0Q0eNzukVs2kQQu3Xk+LYNIBbN0G/Y9JjjgCyFlvKXlSrCehhXqYcID
W/gtzLRn8sG3e5xd81fegw35NAmZ3AJulLl19R5rA7cxi4xDlCKwau9x/Zrr
n8Baa9xtxhadYCdNZGNAbRe4K9Wxp8OqF2yaq1irXugDK9RSyZD9ALhyrqmT
+kQMptJfLcrlg+CsK4LYUvMv4NWTXHlcyjA4yUHE39U+ApbWijL7GV/BP5mD
BZZ3v4GtT+lsxDaNgT3KGZfrDSX4L3qE2WSoFGyjDNIb9p0Ab9df0hWtoykt
Bbw9hZPgq45No5u9ZWDu2ajSj6tolcJo23TeFFgQ4KHNcZeDUzzZJfxpNGPc
a6SC/R189HAqh3CYBoea9K6RxWhVZ7YsnvUDnE8JT/I3n8H9EkG5lgi96T4r
0DlhFkyqDufJDObAiS942QZt6GbrdF3aDQWY5pVo85CqBI/Z9omThei6Yldz
efg8OIznRKNvoB+wy1hjbxbANTP0AqrPIji9iB0pOYeO9p+3qPVD7xYK63yD
0Rk5FzuyotBxTs+XtySjzVJ3eOpUoTeO3Ns6/Bo9Oj81UMVF5wY3hJ2pR2us
/G+xheix/pxibTH6XZr6kngIzXGJsKwYQXu/PMA/LUF/uNP9mTWLzrM9lOOn
RCfICgMZi+j9PtekrStoCnmwMleNnhC4MCPX0UJmhZ39L/QzUz2VRoP+DRRC
Ph8=
      "]]}, 
    {Hue[0.14213595499957954`, 0.6, 0.6], Dashing[{0.1, 0}], 
     LineBox[CompressedData["
1:eJwV0/k/FPgfwHFHxS6xatsi8XBWCNsWW63eK21EkitHQpGNlGNRU8lXTKhQ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      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{
    FormBox["\"\[Mu]\"", TraditionalForm], 
    FormBox["\"x\"", TraditionalForm]},
  ImageSize->360,
  PlotLabel->FormBox["\"Supercritical Pitchfork\"", TraditionalForm],
  PlotRange->{{-1, 1}, {-1, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.545554508296875*^9}]
}, Open  ]]
},
WindowSize->{1272, 679},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"7.0 for Microsoft Windows (32-bit) (November 10, 2008)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 479, 14, 33, "Input"],
Cell[1027, 36, 346, 13, 40, "Input"],
Cell[CellGroupData[{
Cell[1398, 53, 61, 1, 31, "Input"],
Cell[1462, 56, 149, 4, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1648, 65, 61, 1, 31, "Input"],
Cell[1712, 68, 167, 5, 37, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1916, 78, 61, 1, 31, "Input"],
Cell[1980, 81, 188, 6, 37, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2205, 92, 1027, 28, 92, "Input"],
Cell[3235, 122, 1516, 32, 263, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4788, 159, 1536, 42, 127, "Input"],
Cell[6327, 203, 6386, 116, 263, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12750, 324, 241, 7, 31, "Input"],
Cell[12994, 333, 7418, 134, 263, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
